#include <PalmOS.h>
#include "CommonFunc.hpp"
/*
      str ("16.17.2003"),  , , 
*/

Boolean StrToDate(Char *str, Int16 *day, Int16 *month, Int16 *year)
{
  Char *edText;
  if (str){
    if (StrLen(str)<10){
	  return false;
	}
	edText = (Char *)MemPtrNew(6);
	StrCopy(edText+2,"\0");
	StrNCopy(edText, str, 2);
	*day   =   StrAToI (edText);
	StrNCopy(edText, str + 3, 2);
	*month =   StrAToI (edText);
	StrNCopy(edText, str + 6, 4);
	StrCopy(edText+4,"\0");
	*year  = StrAToI (edText);/**/
    MemPtrFree(edText);
	return true; 	  
  }
  else return false;
}
/*
   StrToDate
*/

Boolean DateToStr(Int16 day, Int16 month, Int16 year, Char *str)
{
  if (str){
    if (MemPtrSize(str)<11){
	  return false;
	}
	if (day > 0){
  	  if (day < 10) { str = StrCopy(str,"0"); str = StrIToA(str+1,day); str = str - 1;}
	  else str = StrIToA(str,day);
	  str = StrCopy(str + 2,".");
	  if (month < 10) { str = StrCopy(str + 1,"0"); str = StrIToA(str+1,month); str = str - 1;}
	  else str = StrIToA(str + 1,month);
  	  str = StrCopy(str + 2,".");
	}
	else{
	  str = StrIToA(str, month);
	  if (month > 9) str = StrCopy(str + 2,".");
	  else str = StrCopy(str + 1,".");
	}  
	    
	str = StrIToA(str + 1,year);
	return true;
  }
  else return false;
}

Int16 GetDayOfWeek(MyDatePtr lDate)
{ 
  Int16 i;
  if (lDate->day == 0) return 0; 
  i = DayOfWeek (lDate->month, lDate->day, lDate->year);
  //i = i - 1;
  if (i == 0) return 7;
  else  return i;
}


Int32 DaysBeetwin(MyDatePtr FrDate, MyDatePtr ToDate)
{ 
  DateType date;
  Int32 i,j, res;
  
  date.year = FrDate->year - 1904;
  date.month = FrDate->month;
  date.day = FrDate->day;
  i = DateToDays (date);  
  date.year = ToDate->year - 1904;
  date.month = ToDate->month;
  date.day = ToDate->day;
  j = DateToDays (date);
  res = j - i;
  if (res < 0) return (res - 1);
  else  return (res + 1);
}

Int32 MonthsBeetwin(MyDatePtr FrDate, MyDatePtr ToDate)
{ 
  Int32 res;
  
  res = (ToDate->year - FrDate->year)*12 + ToDate->month - FrDate->month; 
  return res;
}

Boolean MonthAdjust(MyDatePtr myDate, Int32 IncMonth)
{ 
  DateType date;
  Int32 res;
  
  myDate->month = myDate->month + IncMonth;
  if (myDate->month > 12){
    myDate->year = myDate->year + (myDate->month / 12);
    myDate->month = (myDate->month % 12);
  }	
	
  return true;
}

Boolean DayAdjust(MyDatePtr myDate, Int32 IncDay){
  DateType date;
  
  MyDateToDate(myDate, &date);
  DateAdjust(&date, IncDay);
  DateToMyDate(&date, myDate);
}			

Boolean DateToMyDate(DateType *date, MyDatePtr mdate)
{
  mdate->year = date->year + 1904;
  mdate->day = date->day;
  mdate->month = date->month;
  return true;
}

Boolean MyDateToDate(MyDatePtr mdate, DatePtr date)
{
  date->year  = mdate->year - 1904;
  date->day   = mdate->day;
  date->month = mdate->month;
  return true;
}


/*
   
  0 -  
  1 - Date1 > Date2
  -1 - Date1 < Date2
*/
Int8 CompareMyDate(MyDatePtr Date1, MyDatePtr Date2)
{ 
  if( (Date1->year < Date2->year) ||
     ((Date1->year ==  Date2->year) &&
      (Date1->month < Date2->month)) ||
     ((Date1->year ==  Date2->year) &&
      (Date1->month == Date2->month) &&
      (Date1->day < Date2->day)) 
	) 
  {
    return -1;
  }	
  else
  if ((Date1->year ==  Date2->year) &&
      (Date1->month == Date2->month) &&
      (Date1->day == Date2->day))
  {
	return 0; 
  }	   
  else return 1;
}


void FloatToCurrency(FlpCompFloat flp, Char *p, Int8 dec)
{   UInt16 i;
	//FlpCompFloat lFloat;
	//Int32 lInt;
	//Char *ch;
	UInt8 len;
	
	//lFloat = flp;
	//lInt = _f_ftoi(lFloat.ff); //   
	//lFloat.f = lFloat.f - lInt; //   
	
	for(i = 0; i < dec; ++i) 
		flp.f = flp.f * 10;
	StrIToA(p, _f_ftoi(flp.ff));
	if (StrLen(p)<dec) {
		for(i = StrLen(p); i <= dec; ++i) p = StrCat(p,"0");
	}
	len = StrLen(p);
	//   
    for(i = len ; i > (len - dec - 1); --i) p[i+1] = p[i];
	p[len-dec] = '.';
}

void ClearMem(Char *p, UInt32 len)
{  Int32 i;
   Int8 *val; 

  //val = 0;
  for(i = 0; i < len; ++i){
    val = (Int8 *)(p + i);
	*val = 0;
  }
     
}
UInt16 GetObjectIndexFromPtr (const FormType *formP, void *objP)
{
  UInt16 index; 
  UInt16 objIndex = frmInvalidObjectId; 
  UInt16 numObjects = FrmGetNumberOfObjects(formP); 
  for (index = 0; index < numObjects; index++) { 
       if (FrmGetObjectPtr(formP, index) == objP) { 
            // Found it 
            objIndex = index;
            break; 
       } 
  }
  return objIndex;  
} 
