#include "FinDataModule.hpp"
#include "TChartSeries.hpp"
TDataSet *DSAccTo = NULL;
TDataSet *DSAccFr = NULL;
TDataSet *DSTrans = NULL;
TDataSet *DSCond = NULL;
TDataSet *DSSeries = NULL;  //  
TDataSet *DSPoints = NULL;	//  
TDataSet *DSCurr = NULL;	// 
TProgressBar *ProgressBar = NULL;

TField *fldActiveCond;
UInt32 *ArrAccFr, *ArrAccTo; //    
UInt32 *ArrFrSize, *ArrToSize; //    
MyDateType dateFr, dateTo;
//UInt32 ValidRecCount = 0;
Char *DB_CREATOR = "ArFD";

//   
Boolean GetValidRec(TDataSet *dataset)
{
  UInt32 *AccNum, i;
  Boolean key;
  MyDateType *date;
  
  //       
  AccNum = (UInt32 *)dataset->GetFieldData(dataset->GetFieldByName("ACC_FR_ID"), false);
  key = false;
  for(i = 0; i < ((*ArrFrSize)/4); ++i){
    if (ArrAccFr[i] == *AccNum){
	  key = true;
	  break;
	}
  }
  if (key){
    AccNum = (UInt32 *)dataset->GetFieldData(dataset->GetFieldByName("ACC_TO_ID"), false);
    key = false;
    for(i = 0; i < ((*ArrToSize)/4); ++i){
      if (ArrAccTo[i] == *AccNum){
  	  key = true;
 	   break;
	  }
    }
  }
  /*
   
  0 -  
  1 - Date1 > Date2
  -1 - Date1 < Date2 */
  if (key){
    /*if (ValidRecCount == 82){ 
  	  DSTrans->set_Position(1920);
	  date = (MyDateType *)DSTrans->GetFieldData(DSTrans->GetFieldByName(""), false);
	  SysFatalAlert(" 1");
	}*/  
  
    date = (MyDateType *)dataset->GetFieldData(dataset->GetFieldByName(""), false);
    key = false;
	if (CompareMyDate(date, &dateFr) >= 0 ) key = true; 
	if (key){
      key = false;
	  if (CompareMyDate(date, &dateTo) <= 0 )
	  { 
	     key = true;
		 /*if (ValidRecCount == 82) 
   	      SysFatalAlert(" 2");
		 ++ValidRecCount;*/
	  }	 
	}  
  }
  ProgressBar->Progress();
  return key;
}


//           
Boolean SetTransFiltered(Boolean filtered, MyDateType *date_fr, MyDateType *date_to)
{
  if (DSTrans == NULL){
    SysFatalAlert ("      !");
	return false;
  }
  if (DSCond == NULL){
    SysFatalAlert ("      !");
	return false;
  }
  if (!filtered) {
    DSTrans->set_Filtered(false);
    return true;
  }
  
  DSTrans->Open();
  DSCond->Open();
  fldActiveCond = DSCond->GetFieldByName("C");
	
  ArrFrSize = (UInt32 *)DSCond->GetFieldData(DSCond->GetFieldByName("AccsFrSize"), false);
  ArrToSize = (UInt32 *)DSCond->GetFieldData(DSCond->GetFieldByName("AccsToSize"), false);
  ArrAccFr = (UInt32 *)DSCond->GetFieldData(DSCond->GetFieldByName("AccsFr"), false);
  ArrAccTo = (UInt32 *)DSCond->GetFieldData(DSCond->GetFieldByName("AccsTo"), false);
  if (!date_fr){
      MyDateType *date;
	  date = (MyDateType *)DSCond->GetFieldData(DSCond->GetFieldByName(" "), false);
	  dateFr = *date;
  } else dateFr = *date_fr;
  if (!date_to){
      MyDateType *date;
	  date = (MyDateType *)DSCond->GetFieldData(DSCond->GetFieldByName(" "), false);
	  dateTo = *date;
  }else dateTo = *date_to;	  
  {
      /*Int8 val = 1;
      //    
      if (!DSCond->LocateByField(fldActiveCond, (Char *)&val)){
	    SysFatalAlert ("    ");
		return false;
      }*/
  }
	
  DSTrans->OnFuncValidateRecType = &GetValidRec;
  ProgressBar->Start(0, DSTrans->RecCount(), " ");
  //ValidRecCount = 0;	
  DSTrans->set_Filtered(true);
  ProgressBar->Finish();
  return true;
} 

Boolean SetTransFiltered(Boolean filtered)
{
   SetTransFiltered(filtered, NULL, NULL);
}

Boolean InitDataSets(void)
{
  //  
  if (DSTrans == NULL){ 
    DSTrans = new TDataSet;
  
	DSTrans->set_DB_NAME("FP_Transaction");
	DSTrans->set_DB_CREATOR("IDfp");
	DSTrans->set_DB_CARDNO(0);
	
	DSTrans->AddField ("ID", fdtInt, 4);
	DSTrans->AddField ("MIRROR_ID", fdtInt, 4);
	DSTrans->AddField ("ACC_TO_ID", fdtInt, 4);
	DSTrans->AddField ("ACC_FR_ID", fdtInt, 4);
	DSTrans->AddField ("", fdtCurrency, 4);
	DSTrans->AddField ("CURRENCY_ID", fdtInt, 4);
	DSTrans->AddField ("CURRENCY_RATE", fdtFloat, 4);
	DSTrans->AddField ("REMINDTYPE_ID", fdtInt, 4);
	DSTrans->AddField ("BALANCETYPE_ID", fdtInt, 4);
	DSTrans->AddField ("CATEGORY1_ID", fdtInt, 4);
	DSTrans->AddField ("CATEGORY2_ID", fdtInt, 4);
	DSTrans->AddField ("CATEGORY3_ID", fdtInt, 4);
	DSTrans->AddField ("CATEGORY4_ID", fdtInt, 4);
  /*UInt16 second;
  UInt16 minute;
  UInt16 hour;*/
	DSTrans->AddField ("Time", fdtOther, 6);
/*  UInt16 day;
  UInt16 month;
  UInt16 year;
  UInt16 weekDay; // 14*/    
	DSTrans->AddField ("", fdtDate, 8);
	DSTrans->AddField ("FOWNCURRENCY", fdtInt, 1);
	DSTrans->AddField ("FADD", fdtInt, 1);
	//FMIRROR = DSTrans->AddField ("FMIRROR", fdtInt, 1);
	DSTrans->AddMemField ("MemFMIRROR", fdtInt, 1);
	DSTrans->AddField ("FREMIND", fdtInt, 1);
	DSTrans->AddField ("FRECEIPT", fdtInt, 1);
	DSTrans->AddField ("FBILLABLE", fdtInt, 1);
	DSTrans->AddField ("FCLEARED", fdtInt, 1);
	DSTrans->AddField ("NOTE", fdtChar, 30);
	DSTrans->Open(); 
  }	
  //   
  if (DSCond == NULL){
	DSCond = new TDataSet;
	DSCond->set_DB_NAME("FD_Conditions");
	DSCond->set_DB_CREATOR(DB_CREATOR);
	DSCond->set_DB_CARDNO(0);
    //fldCondID = DSCond->AddField ("ID", fdtInt, 4);
	//   
    DSCond->AddField ("ID", fdtInt, 4);
    DSCond->AddField ("C", fdtInt, 1);
    DSCond->AddField ("", fdtInt, 1);
	// 
    DSCond->AddField ("", fdtChar, 30);
    //    
    DSCond->AddField (" ", fdtDate, 8);
	//   
	DSCond->AddField (" ", fdtDate, 8);
	//    
	DSCond->AddField ("AccsFrSize", fdtInt, 4);
	DSCond->AddField ("AccsToSize", fdtInt, 4);
	//   
	DSCond->AddFloatSizeField ("AccsFr", fdtInt, DSCond->GetFieldByName("AccsFrSize"));
    //   
	DSCond->AddFloatSizeField ("AccsTo", fdtInt, DSCond->GetFieldByName("AccsToSize"));
	//fldAccsToSize = DSCond->AddField ("AccsToSize", fdtOther, 4);
	if (DSCond->DBExists()) DSCond->Open();
  }	
  if (DSAccTo == NULL){
	//    ""  ""
	DSAccTo = new TDataSet;
    DSAccTo->set_DB_NAME("FP_Account");
    DSAccTo->set_DB_CREATOR("IDfp");
    DSAccTo->set_DB_CARDNO(0);
			
    DSAccTo->AddField ("ID", fdtInt, 4); 
    DSAccTo->AddField ("Amt", fdtCurrency, 4); 
    DSAccTo->AddField ("_1", fdtOther, 4);
    DSAccTo->AddField ("FACTIVE", fdtInt, 1); 
	DSAccTo->AddField ("FTOTAL", fdtInt, 1); 
	DSAccTo->AddField (" ", fdtChar, 30);
	DSAccTo->AddMemField ("C", fdtInt, 1);
    DSAccTo->Open();	
	
	DSAccFr = new TDataSet;
	DSAccFr->set_DB_NAME("FP_Account");
	DSAccFr->set_DB_CREATOR("IDfp");
	DSAccFr->set_DB_CARDNO(0);
			
	DSAccFr->AddField ("ID", fdtInt, 4); 
	DSAccFr->AddField ("Amt", fdtCurrency, 4); 
	DSAccFr->AddField ("_1", fdtOther, 4); 
	DSAccFr->AddField ("FACTIVE", fdtInt, 1); 
	DSAccFr->AddField ("FTOTAL", fdtInt, 1); 
	DSAccFr->AddField (" ", fdtChar, 30);
	DSAccFr->AddMemField ("C", fdtInt, 1);
    //DSAccFr->Open();	
    DSAccFr->Open(DSAccTo->get_dbPtr());
  }
  if (DSSeries == NULL){
    //  
    DSSeries = new TDataSet;
  	DSSeries->set_DB_NAME("FD_Series");
	DSSeries->set_DB_CREATOR(DB_CREATOR);
	DSSeries->set_DB_CARDNO(0);
	
	DSSeries->AddField ("SeriesID", fdtInt, 4); //   
	DSSeries->AddField ("Name", fdtChar, 20); // 
	DSSeries->AddField ("XasDate", fdtInt, 1);
	DSSeries->AddField ("YasDate", fdtInt, 1);
	DSSeries->AddField ("CondID", fdtInt, 4);  // ID  
	if (DSSeries->DBExists()) DSSeries->Open();
  }
  if (DSPoints == NULL){
    //   
    DSPoints = new TDataSet;
  	DSPoints->set_DB_NAME("FD_Points");
	DSPoints->set_DB_CREATOR(DB_CREATOR);
	DSPoints->set_DB_CARDNO(0);
	DSPoints->AddField ("SeriesID", fdtInt, 4); //   
	DSPoints->AddField ("XValue", fdtOther, sizeof(TPointVal));
	DSPoints->AddField ("YValue", fdtOther, sizeof(TPointVal));
	if (DSPoints->DBExists()) DSPoints->Open();
  }
  //   
  if (DSCurr == NULL){
    DSCurr = new TDataSet;
    DSCurr->set_DB_NAME("FP_Currency");
    DSCurr->set_DB_CREATOR("IDfp");
    DSCurr->set_DB_CARDNO(0);
	DSCurr->AddField ("ID", fdtInt, 4); //   
	DSCurr->AddField ("RATE", fdtFloat, 4);
	DSCurr->AddField ("$", fdtChar, 30);
    DSCurr->SetLinkDS(DSTrans->GetFieldByName("CURRENCY_ID"), DSCurr->GetFieldByName("ID"));
    DSCurr->Open();	
  }  
  if (ProgressBar == NULL) ProgressBar = new TProgressBar; 
}

Boolean ReleaseDataSets(void)
{
  if (DSAccTo != NULL) delete DSAccTo;
  if (DSAccFr != NULL) delete DSAccFr;
  if (DSTrans != NULL) delete DSTrans;
  if (DSCond != NULL) delete DSCond;
  if (ProgressBar != NULL) delete ProgressBar;
  if (DSCurr != NULL) delete DSCurr;
  if (DSSeries != NULL) delete DSSeries;
  if (DSPoints != NULL) delete DSPoints;
  
  ProgressBar = NULL;
  DSAccTo = NULL;
  DSAccFr = NULL;
  DSTrans = NULL;
  DSCond = NULL;
  DSCurr = NULL;
  DSSeries = NULL;
  DSPoints = NULL;
}
