 
/************************************************************************
 *
 * Created with Falch.net DeveloperStudio
 * http://www.falch.net/
 * 
 * File : Menu.cpp
 * 
 * Description :  
 *
 * History:
 *			Name		Date					Description
 *			----		----					-----------
 *			U_60OTR	02.10.03 11:35:08		Created

 *
 ***********************************************************************/
 
#include <PalmOS.h>
#include "FinDiagrCPP.hpp"
#include "FinDiagrCPP_res.hpp"
#include "TDataSet.hpp"
#include "frmChart.hpp"
#include "frmTrans.hpp"
#include "FinDataModule.hpp"

static Boolean miLoad_OnSelect(UInt16 menuID)
{
	if (!Chart) return true;
	Chart->Load(ProgressBar); 
	return true;
}

static Boolean miSave_OnSelect(UInt16 menuID)
{
	if (!Chart) return true;
	Chart->Save(ProgressBar); 
	return true;
}

static Boolean miTransShow_OnSelect(UInt16 menuID)
{   Int32 CondID;  

	// Insert code for miTransShow
	Boolean *pisMonth;
	if (!Chart) return true;
	if (!Chart->NearPoint) return true;
	CondID = Chart->NearPoint->Owner->CondID;
	if (!DSCond->LocateByField(DSCond->GetFieldByName("ID"), 
	  (Char *)&CondID)){
	  SysFatalAlert ("      .");
	  return true;
	}

    pisMonth = (Boolean *)DSCond->GetFieldData(DSCond->GetFieldByName(""), false);
	
	if (*pisMonth){
	  MyDateType DtFr, DtTo;
	  DtFr = Chart->NearPoint->XValue.asDate;
	  DtFr.day = 1;
	  DtTo = DtFr;
	  DtTo.day = 31;
      ShowTransOfPeriod(DtFr, DtTo);	
	}else
      ShowTransOfPeriod(Chart->NearPoint->XValue.asDate, Chart->NearPoint->XValue.asDate);	
	return true;
}

static Boolean miDelSeries_OnSelect(UInt16 menuID)
{
	if (!Chart) return true;
	if (!Chart->NearPoint) return true; 
	Chart->RemoveSeries(Chart->NearPoint->Owner);
    Chart->Redraw();
	return true;
}


static Boolean frmAddSeries_OnSelect(UInt16 menuID)
{
	// Insert code for frmAddSeries
	FrmPopupForm(frmCond);
	return true;
}



static Boolean miCond_OnSelect(UInt16 menuID)
{
	// Insert code for miCond
	FrmGotoForm(frmCond);
	return true;
}


static Boolean miHide_OnSelect(UInt16 menuID)
{
	return true;
}



static Boolean miShow_OnSelect(UInt16 menuID)
{
}

static Boolean miOnOffMdlLine_OnSelect(UInt16 menuID)
{
	// Insert code for miOnOffMdlLine
	if (Chart){
	  Chart->DrawMiddleLine = !Chart->DrawMiddleLine;
      Chart->Redraw();
	}    
	return true;
}


/***********************************************************************
 *
 * FUNCTION:	ApplicationHandleMenu
 *
 * DESCRIPTION:	This routine handles menu events
 *
 * PARAMETERS:	 id of the menu recieveing a click
 *					
 * RETURNED:	 handled/not handled
 *
 * REVISION HISTORY:
 *			Name		Date					Description
 *			----		----					-----------
 *			U_60OTR	02.10.03 11:35:08		Created

 * 
 ***********************************************************************/

Boolean ApplicationHandleMenu(UInt16 menuID)
{
	Boolean handled = false;
	
	switch (menuID)
	{
		// Event handler for menu item
		case miLoad:
			handled = miLoad_OnSelect(menuID);
			break;
		// Event handler for menu item
		case miSave:
			handled = miSave_OnSelect(menuID);
			break;
		// Event handler for menu item
		case miDelSeries:
			handled = miDelSeries_OnSelect(menuID);
			break;
		// Event handler for menu item
		case miTransShow:
			handled = miTransShow_OnSelect(menuID);
			break;
		// Event handler for menu item
		case miOnOffMdlLine:
			handled = miOnOffMdlLine_OnSelect(menuID);
			break;
		// Event handler for menu item
		case frmAddSeries:
			handled = frmAddSeries_OnSelect(menuID);
			break;
		// Event handler for menu item
		case miCond:
			handled = miCond_OnSelect(menuID);
			break;
		// Event handler for menu item
		case miHide:
			handled = miHide_OnSelect(menuID);
			break;
		// Event handler for menu item
		case miShow:
			handled = miShow_OnSelect(menuID);
			break;
		default:
			break;
	}

	return handled;
}
