// TChart
#include "TChart.hpp"
// Class TChart 
TChart::TChart(TDataSet *dsseries, TDataSet *dspoints)
{
  Series = new TList;
  Width = 140;
  Height = 110;
  Top = 20;
  Left = 5;
  yAxisOffset = 15; 
  DSPoints = dspoints;
  DSSeries = dsseries;
  NearPoint = NULL;
  DrawMiddleLine = true;  
}

TChart::TChart(const TChart &right)
{
}


TChart::~TChart()
{
  delete Series;
}



TChart & TChart::operator=(const TChart &right)
{
}


int TChart::operator==(const TChart &right) const
{
}

int TChart::operator!=(const TChart &right) const
{
}

TChartSeries *TChart::AddSeries(Char *SeriesName)
{ TChartSeries *series;

  series = new TChartSeries(this, SeriesName); 
  Series->Add(series);
  return series;
}

Int32 TChart::SeriesCount() //  
{
  return Series->Count();
}


Boolean TChart::RemoveSeries(Int32 index)
{
  TChartSeries *series;
  
  series = (TChartSeries *)Series->Item(index);
  if (NearPoint->Owner == series) NearPoint = NULL; 
  if (series != NULL) delete series;
  Series->Delete(index);
  return true;
}

Boolean TChart::RemoveSeries(TChartSeries *series)
{  Int32 index;

  index = IndexOf(series);
  if (index == -1){
    return false; 
  } else
  return RemoveSeries(index);  
}


TChartSeries *TChart::GetSeries(Int32 index)
{
  return (TChartSeries *)Series->Item(index);
}


FlpCompFloat TChart::XValueToXCoord(FlpCompFloat xValue){
  xValue.f = Left + (xValue.f - minX.f)*ScaleX.f; 
  return xValue; 
}

FlpCompFloat TChart::YValueToYCoord(FlpCompFloat yValue){
  yValue.f = Top + Height - (yValue.f - minY.f)*ScaleY.f;
  return yValue; 
}

Boolean TChart::Redraw()
{
	FlpCompFloat x, y, prevx, prevy;
	Int32 seriescount, i;

	Int32 j, MaxPointCount, len;
	//IndexedColorType curColor;
	
	RectangleType rm;
	
	NearPoint = NULL;
	
	WinSetDrawMode(winPaint);
	rm.topLeft.x = Left; 
	rm.topLeft.y = Top;
	rm.extent.x = Left + Width; 
	rm.extent.y = Top + Height;
	WinSetForeColor (0);
    WinDrawRectangle (&rm, 0);
	
	maxY.f = -999999;
	minY.f = 9999999;
	minX = minY;
	maxX = maxY;
	//maxIndex = -1;
	//minIndex = -1;
	MaxPointCount = 0;
	seriescount = Series->Count();
	//      
    for (i=0; i < seriescount; ++i){
      TChartSeries *series;
	  Int32 pointscount;
	  series = (TChartSeries *)Series->Item(i);
	  pointscount = series->PointsCount();
	  if (MaxPointCount < pointscount) 
	    MaxPointCount = pointscount;
	  if (maxY.f < series->GetMaxYValue().f) maxY = series->GetMaxYValue();  
	  if (minY.f > series->GetMinYValue().f) minY = series->GetMinYValue();  
	  if (maxX.f < series->GetMaxXValue().f) maxX = series->GetMaxXValue();  
	  if (minX.f > series->GetMinXValue().f) minX = series->GetMinXValue();  
    }
	
	ScaleX.f = Width / (maxX.f - minX.f);
	ScaleY.f = Height / (maxY.f - minY.f);
	
	
	//   
	WinSetForeColor (10);
	x.f = Left; 
	y.f = Top;
	prevx.f = Left;
	prevy.f = Top + Height + yAxisOffset;
	WinDrawLine (_f_ftoi(prevx.ff), _f_ftoi(prevy.ff), _f_ftoi(x.ff), _f_ftoi(y.ff));
	x.f = Width + Left; 
	y.f = prevy.f;
	WinDrawLine (_f_ftoi(prevx.ff), _f_ftoi(prevy.ff), _f_ftoi(x.ff), _f_ftoi(y.ff));
	//curColor = 16;
    WinSetForeColor (15);
	//  -   
	
    //  
    for (i = 0; i < seriescount; ++i){ //   
      TChartSeries *series;
	  Int32 j, PointsCount;
	  FlpCompFloat sumAmt;
	  
	  series = (TChartSeries *)Series->Item(i);
	  PointsCount = series->PointsCount();
	  sumAmt.f = 0; 
	  for (j = 0; j < PointsCount; ++j){ //   
        TSeriesPoint *point;
		//MyDateType *lDate;
		Int8 dayofweek;
		
		point = series->Point(j); 	  
	    //x = point->XValue.asFloat;
		x = point->GetXValueAsFloat(series->get_XasDate());
		//x.f = Left + (x.f - minX.f)*ScaleX.f;
		x = XValueToXCoord(x);
		//y = point->YValue;
		y = point->GetYValueAsFloat(series->get_YasDate());
		sumAmt.f = sumAmt.f + y.f; 
		//y.f = Top + Height - (y.f - minY.f)*ScaleY.f;
		y = YValueToYCoord(y);
        WinSetForeColor (15);
		//  
	    if (j != 0)
 		  WinDrawLine (_f_ftoi(prevx.ff), _f_ftoi(prevy.ff), _f_ftoi(x.ff), _f_ftoi(y.ff));
		  
        WinSetForeColor (10);
		//   
        WinDrawLine (_f_ftoi(x.ff) - 1, _f_ftoi(y.ff)-1, _f_ftoi(x.ff)+1, _f_ftoi(y.ff)+1);
        WinDrawLine (_f_ftoi(x.ff) + 1, _f_ftoi(y.ff)-1, _f_ftoi(x.ff) - 1, _f_ftoi(y.ff)+1);
		//      
		//lDate = point->XValue.asDate;
		
		dayofweek = GetDayOfWeek(&point->XValue.asDate); 
		if ((dayofweek == 6)||(dayofweek == 7) ){
	        WinSetForeColor (6);
        	WinDrawLine (_f_ftoi(x.ff), Top, _f_ftoi(x.ff), Top + Height + yAxisOffset);
	        WinSetForeColor (15);
		}  
		prevx = x;
		prevy = y;
	  }

	  //  
	  if (DrawMiddleLine){
	    Char *p;
		
	    WinSetTextColor (10);
	    WinSetForeColor (5);
	    sumAmt.f = sumAmt.f/PointsCount;
 	    y = YValueToYCoord(sumAmt);
	    WinDrawLine (Left, _f_ftoi(y.ff), Left + Width, _f_ftoi(y.ff));
	    rm.topLeft.x = Left + 5;
	    rm.topLeft.y = _f_ftoi(y.ff) + 2;
	    p = (Char *)MemPtrNew(30);
	    FloatToCurrency(sumAmt, p, 2);   
		
	    //rm.extent.x = 50;
		rm.extent.x = FntLineWidth (p, StrLen(p));  
	    rm.extent.y = FntLineHeight(); 
 	    WinPaintChars (p, StrLen(p), rm.topLeft.x, rm.topLeft.y);
		MemPtrFree(p);
	  }	
    }
    WinSetTextColor (15); 		  
    WinSetForeColor (15);
	return true;
}

//  DataSet'
Boolean TChart::InitDS()
{
	return true;
}
//    
Boolean TChart::Save(TProgressBar *ProgressBar)
{  
   Int32 i, seriescount;
   Int8 XasDate, YasDate;
   
   if (!InitDS()) return false;
   DSSeries->Drop();  
   DSSeries->CreateDB();
   DSSeries->Open();
   DSPoints->Drop();  
   DSPoints->CreateDB();
   DSPoints->Open();
	
	seriescount = SeriesCount();
    for (i = 0; i < seriescount; ++i){ //   
      TChartSeries *series;
	  Int32 j, PointsCount;
	  Int8 val;
	  
	  series = (TChartSeries *)Series->Item(i);
	  PointsCount = series->PointsCount();
	  
	  XasDate = series->get_XasDate();  
	  YasDate = series->get_YasDate();  
	  
	  DSSeries->Insert();
	  DSSeries->SetFieldData(DSSeries->GetFieldByName("SeriesID"), (Char *)&i, false);
	  
	  DSSeries->SetFieldData(DSSeries->GetFieldByName("XasDate"), (Char *)&XasDate, false);
	  DSSeries->SetFieldData(DSSeries->GetFieldByName("YasDate"), (Char *)&YasDate, false);
	  DSSeries->SetFieldData(DSSeries->GetFieldByName("Name"), (Char *)&(series->Name), false);
	  DSSeries->SetFieldData(DSSeries->GetFieldByName("CondID"), (Char *)&(series->CondID), false);
	  
	  
	  if (ProgressBar) ProgressBar->Start(0, PointsCount, " ");
	  for (j = 0; j < PointsCount; ++j){ //   
        TSeriesPoint *point = series->Point(j);
		//point = series->Point(j); 	  
  	    DSPoints->Insert();
	    DSPoints->SetFieldData(DSPoints->GetFieldByName("SeriesID"), (Char *)&i, false);
	    DSPoints->SetFieldData(DSPoints->GetFieldByName("XValue"), (Char *)&(point->XValue), false);
	    DSPoints->SetFieldData(DSPoints->GetFieldByName("YValue"), (Char *)&(point->YValue), false);
 	    if (ProgressBar) ProgressBar->Progress();
	  }	
	}
  if (ProgressBar) ProgressBar->Finish();
  if (ProgressBar) Redraw();  
  return true;
}


//    
Boolean TChart::Load(TProgressBar *ProgressBar)
{  
   Int32 i, seriescount, pointscount;
   Int8 *XasDate, *YasDate;
   Int32 *SeriesID;
   Char *name;
   TField *fldSeriesID;
   
   
   if (!InitDS()) return false;
   if (!DSSeries->DBExists()) return false;  
   if (!DSPoints->DBExists()) return false;  
   DSSeries->Open();
   DSPoints->Open();
   seriescount = DSSeries->RecCount();
   pointscount = DSPoints->RecCount();
   if (!seriescount) return false;
   fldSeriesID = DSPoints->GetFieldByName("SeriesID");
   
   if (ProgressBar) ProgressBar->Start(0, pointscount, " ");
   for (i = 0; i < pointscount; ++i){ //   
      TChartSeries *series;
	  Int32 *CurSeriesID;
	  //Int8 val;
      TSeriesPoint point;
	  TPointVal *pointval;
	  
	  DSPoints->set_Position(i);
	  CurSeriesID = (Int32 *)DSPoints->GetFieldData(fldSeriesID, false); 
	  //   
	  if ((i == 0)||(*CurSeriesID != *SeriesID)){
	    Int32 *CondID;
  	    SeriesID = CurSeriesID;
		//series = new TChartSeries(this);
		if (!DSSeries->LocateByField(DSSeries->GetFieldByName("SeriesID"), (Char *)SeriesID)){
		  SysFatalAlert (" .     ID");
		}
		XasDate = (Int8 *)DSSeries->GetFieldData(DSSeries->GetFieldByName("XasDate"), false);
		YasDate = (Int8 *)DSSeries->GetFieldData(DSSeries->GetFieldByName("YasDate"), false);
		name = (Char *)DSSeries->GetFieldData(DSSeries->GetFieldByName("Name"), false);
		CondID = (Int32 *)DSSeries->GetFieldData(DSSeries->GetFieldByName("CondID"), false);
		
		series = AddSeries(name);
		series->set_XasDate(*XasDate);
		series->set_YasDate(*YasDate);
		series->CondID = *CondID;
		//AddSeries(series);
	  }
	  //  
	  pointval = (TPointVal *)DSPoints->GetFieldData(DSPoints->GetFieldByName("XValue"), false); 
	  point.XValue = *pointval; 
	  pointval = (TPointVal *)DSPoints->GetFieldData(DSPoints->GetFieldByName("YValue"), false); 
	  point.YValue = *pointval; 
	  series->AddPoint(point);
      if (ProgressBar) ProgressBar->Progress();
   }
  if (ProgressBar) ProgressBar->Finish();
  if (ProgressBar) Redraw();  
  return true;
}


//  
Boolean TChart::DrawCrosshair(){

	if (NearPoint != NULL){
        RectangleType bounds;
	    Char *p;
	    FlpCompFloat x,y;
	   //  
		x = NearPoint->GetXValueAsFloat();
		x = XValueToXCoord(x);
		y = NearPoint->GetYValueAsFloat();
		y = YValueToYCoord(y);
 	   WinPaintLine(_f_ftoi(x.ff), Top, _f_ftoi(x.ff), Top + Height + yAxisOffset);
	   WinPaintLine(Left, _f_ftoi(y.ff), Left + Width, _f_ftoi(y.ff));
	   
        //  
  		bounds.topLeft.x = Left + 5; 
		bounds.topLeft.y = Top;
		bounds.extent.x = 50; 
		bounds.extent.y = FntLineHeight()*2; 
	    p = (Char *)MemPtrNew(30);
		NearPoint->GetXValueAsString(p);
 		WinPaintChars (p, StrLen(p), bounds.topLeft.x, bounds.topLeft.y);
		NearPoint->GetYValueAsString(p);
 		WinPaintChars (p, StrLen(p), bounds.topLeft.x, bounds.topLeft.y + FntLineHeight());
		MemPtrFree(p);
		
	  //   
	    if (NearPoint->Owner != NULL){
	      p = NearPoint->Owner->Name;
		  bounds.extent.x = FntLineWidth(p, StrLen(p)); 
  		  bounds.topLeft.x = Left + (Width - bounds.extent.x); 
		  bounds.topLeft.y = Top;
		  bounds.extent.y = FntLineHeight(); 
 		  WinPaintChars (p, StrLen(p), bounds.topLeft.x, bounds.topLeft.y);
		}  
	}
}

Boolean TChart::DrawPenPos(EventPtr event){
	Int32 seriescount, i;
	Int32 j, MaxPointCount, len;
	FlpCompFloat x,y, curx, cury, MinDistance, distance;
    TSeriesPoint *NewNearPoint;
	
	
    MinDistance.f = 99999999;
	curx.f = event->screenX;
	cury.f = event->screenY;
	
    NewNearPoint = NULL;

    //        
  	seriescount = Series->Count();
    for (i = 0; i < seriescount; ++i){ //   
      TChartSeries *series;
	  Int32 j, PointsCount;
	  
	  series = (TChartSeries *)Series->Item(i);
	  PointsCount = series->PointsCount();
	   
	  for (j = 0; j < PointsCount; ++j){ //   
        TSeriesPoint *point;
		point = series->Point(j);
		
		x = point->GetXValueAsFloat(series->get_XasDate());
		x = XValueToXCoord(x);
		y = point->GetYValueAsFloat(series->get_YasDate());
		y = YValueToYCoord(y);
		
		distance.f = (curx.f - x.f)*(curx.f - x.f) + (cury.f - y.f)*(cury.f - y.f);
		if (distance.f <  MinDistance.f){
		  MinDistance.f = distance.f;
		  NewNearPoint = point; 
		} 
	  }	 	  
	} 
	if (NewNearPoint != NearPoint){
	  WinSetDrawMode(winInvert);
	  WinSetTextColor (10);
	  WinSetForeColor (5);
	  DrawCrosshair();
	  NearPoint = NewNearPoint; 
	  DrawCrosshair();
	}  
  WinSetTextColor (15);
  WinSetForeColor (15);
  return true;
}

Int32 TChart::IndexOf(TChartSeries *series){
   Int32 i, seriescount, pointscount;

	seriescount = SeriesCount(); 
    for (i = 0; i < seriescount; ++i){ //   
	  if (series == Series->Item(i)){
	    return i;
	    break;
	  }
    }  
  return -1;	
}

Boolean TChart::Event_Handler(EventPtr event){

	switch (event->eType)
	{
	    case penDownEvent:
			DrawPenPos(event);
            return true;
			break;
	    case penMoveEvent:
			DrawPenPos(event);
            return true;
			break;
	}		
  return false;
}
