#ifndef TChart_h
#define TChart_h 1
#include <PalmOS.h> 
#include "TChartSeries.hpp"
#include "TDataSet.hpp"
#include "TProgressBar.hpp"
class TChart 
{
  public:
    //## Constructors (generated)
      TChart(TDataSet *dsseries, TDataSet *dspoints);

      TChart(const TChart &right);

    //## Destructor (generated)
      ~TChart();

    //## Assignment Operation (generated)
      TChart & operator=(const TChart &right);

    //## Equality Operations (generated)
      int operator==(const TChart &right) const;

      int operator!=(const TChart &right) const;

      const Int32 get_Width () const;
      void set_Width (Int32 value);
	  
      const Int32 get_Height () const;
      void set_Height (Int32 value);
	  
      const Int32 get_Top () const;
      void set_Top (Int32 value);

      const Int32 get_Left () const;
      void set_Left (Int32 value);
	  
	  Boolean Redraw();
	  
	  //Boolean AddSeries(TChartSeries *series);
      TChartSeries *AddSeries(Char *SeriesName);	  
      Int32 SeriesCount(); //  
	  Boolean RemoveSeries(Int32 index);
	  Boolean RemoveSeries(TChartSeries *series);

      TChartSeries *GetSeries(Int32 index);
      //    
      Boolean Save(TProgressBar *ProgressBar);
	  Boolean Load(TProgressBar *ProgressBar);
 	  Boolean Event_Handler(EventPtr event);
      Boolean DrawPenPos(EventPtr event);
      FlpCompFloat XValueToXCoord(FlpCompFloat xValue);
      FlpCompFloat YValueToYCoord(FlpCompFloat yValue);
	  Int32 IndexOf(TChartSeries *series);
	  
	  Boolean DrawMiddleLine;
      TSeriesPoint *NearPoint; //      
  protected:
  private:
    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: ScaleX%3FB9C8A60006
      const FlpCompFloat get_ScaleX () const;
      void set_ScaleX (FlpCompFloat value);

      //## Attribute: ScaleY%3FB9D12A00B8
      const FlpCompFloat get_ScaleY () const;
      void set_ScaleY (FlpCompFloat value);
	  Boolean InitDS();
      //  
      Boolean DrawCrosshair();
  private: 
      FlpCompFloat ScaleX;
      FlpCompFloat ScaleY;
	  FlpCompFloat maxY, minY, minX, maxX;
      Int32 Width;
      Int32 Height;
      Int32 Top;
      Int32 Left;
	  Int32 yAxisOffset;
	  TList *Series;
	  
      TDataSet *DSSeries;
      TDataSet *DSPoints;	  
};

// Class TChart 
inline const FlpCompFloat TChart::get_ScaleX () const
{
  return ScaleX;
}

inline void TChart::set_ScaleX (FlpCompFloat value)
{
  ScaleX = value;
}

inline const FlpCompFloat TChart::get_ScaleY () const
{
  return ScaleY;
}

inline void TChart::set_ScaleY (FlpCompFloat value)
{
  ScaleY = value;
}
inline const Int32 TChart::get_Width () const
{
  return Width;
}

inline void TChart::set_Width (Int32 value)
{
  Width = value;
}

inline const Int32 TChart::get_Height () const
{
  return Height;
}

inline void TChart::set_Height (Int32 value)
{
  Height = value;
}

inline const Int32 TChart::get_Top () const
{
  return Top;
}

inline void TChart::set_Top (Int32 value)
{
  Top = value;
}

inline const Int32 TChart::get_Left () const
{
  return Left;
}

inline void TChart::set_Left (Int32 value)
{
  Left = value;
}

#endif
