#include "TChartSeries.hpp"

TSeriesPoint::TSeriesPoint(TChartSeries *owner){
  Owner = owner;
}

TSeriesPoint::TSeriesPoint(){
  Owner = NULL;
}
// Class TSeriesPoint
FlpCompFloat TSeriesPoint::GetXValueAsFloat(Boolean isDate)
{ FlpCompFloat f;
  MyDateType FrDate;
  
  if (!isDate) return XValue.asFloat;
  FrDate.day = 1;
  FrDate.month = 1;
  FrDate.year = 1904;
  f.f = DaysBeetwin(&FrDate, &XValue.asDate);
  return f; 
};

FlpCompFloat TSeriesPoint::GetXValueAsFloat(){
  ErrFatalDisplayIf(Owner == NULL, "TSeriesPoint. GetXValueAsFloat. Owner = NULL");
  return GetXValueAsFloat(Owner->get_XasDate());
}


FlpCompFloat TSeriesPoint::GetYValueAsFloat(Boolean isDate)
{ FlpCompFloat f;
  MyDateType FrDate;
  
  if (!isDate) return YValue.asFloat;
  FrDate.day = 1;
  FrDate.month = 1;
  FrDate.year = 1904;
  f.f = DaysBeetwin(&FrDate, &YValue.asDate);
  return f; 
};

FlpCompFloat TSeriesPoint::GetYValueAsFloat(){
  ErrFatalDisplayIf(Owner == NULL, "TSeriesPoint. GetYValueAsFloat. Owner = NULL");
  return GetYValueAsFloat(Owner->get_YasDate());
}

Char *TSeriesPoint::GetXValueAsString(Char *p){
  if (Owner->get_XasDate()){
    ErrFatalDisplayIf(
	  !DateToStr(XValue.asDate.day, XValue.asDate.month, XValue.asDate.year, p), 
	  "TSeriesPoint.     ");
  }
  else{
    FloatToCurrency(XValue.asFloat, p, 2);   
  }
  return p; 
}

Char *TSeriesPoint::GetYValueAsString(Char *p){
  if (Owner->get_YasDate()){
    ErrFatalDisplayIf(
	  !DateToStr(YValue.asDate.day, YValue.asDate.month, YValue.asDate.year, p), 
	  "TSeriesPoint.     ");
  }
  else{
    FloatToCurrency(YValue.asFloat, p, 2);   
  }
  return p; 
}


// Class TChartSeries 
TChartSeries::TChartSeries(TChart *owner, Char *name)
{
  Points = new TList;
  XasDate = false;
  YasDate = false;
  StrPrintF(Name,"%s", name);
  Owner = owner; 
}

TChartSeries::TChartSeries(const TChartSeries &right)
{
}


TChartSeries::~TChartSeries()
{ Int32 i, count;
  TSeriesPoint *temp;
  //   
  count = Points->Count();
  for (i=0; i < count; ++i){
    temp = (TSeriesPoint *)Points->Item(i);
	delete temp;
  }
  delete Points;
}


TChartSeries & TChartSeries::operator=(const TChartSeries &right)
{
}


int TChartSeries::operator==(const TChartSeries &right) const
{
}

int TChartSeries::operator!=(const TChartSeries &right) const
{
}

Int32 TChartSeries::PointsCount(void)
{
  return Points->Count();
}

TSeriesPoint *TChartSeries::Point(Int32 index)
{
  return (TSeriesPoint *)Points->Item(index);
}

Int32 TChartSeries::AddPoint(TSeriesPoint point)
{
  TSeriesPoint *newPoint;
  
  newPoint = new TSeriesPoint(this);
  newPoint->XValue = point.XValue;
  newPoint->YValue = point.YValue;
  //newPoint->Owner = this;
  Points->Add(newPoint);
  return (Points->Count() - 1);
}



FlpCompFloat TChartSeries::GetMaxValue(UInt8 xyz) // 0 - x, 1 - y, 2 - z
{
  TSeriesPoint *temp;
  FlpCompFloat f;
  Int32 count, i;
  
  count = Points->Count();
  f.f = -9999999;
  for (i = 0; i < count; ++i){
    temp = (TSeriesPoint *)Points->Item(i);
	if (xyz == 0) {if (f.f < temp->GetXValueAsFloat(XasDate).f) 
	  f.f = temp->GetXValueAsFloat(XasDate).f;}
	else
	if (xyz == 1) {if (f.f < temp->GetYValueAsFloat(YasDate).f) 
	  f.f = temp->GetYValueAsFloat(YasDate).f;}
	//if (xyz == 1) {if (f.f < temp->YValue.asFloat.f) f.f = temp->YValue.asFloat.f;}
  }
  return f;
}  

FlpCompFloat TChartSeries::GetMinValue(UInt8 xyz) // 0 - x, 1 - y, 2 - z
{
  TSeriesPoint *temp;
  FlpCompFloat f;
  Int32 count, i;
  
  count = Points->Count();
  f.f = 9999999;
  for (i = 0; i < count; ++i){
    temp = (TSeriesPoint *)Points->Item(i);
	if (xyz == 0) {if (f.f > temp->GetXValueAsFloat(XasDate).f) f.f = temp->GetXValueAsFloat(XasDate).f;}
	else
	if (xyz == 1) {if (f.f > temp->GetYValueAsFloat(YasDate).f) f.f = temp->GetYValueAsFloat(YasDate).f;}
  }
  return f;
}  



FlpCompFloat TChartSeries::GetMaxXValue()
{
  return GetMaxValue(0); // 0 - x, 1 - y, 2 - z;
}  

FlpCompFloat TChartSeries::GetMaxYValue()
{
  return GetMaxValue(1); // 0 - x, 1 - y, 2 - z;
}  

FlpCompFloat TChartSeries::GetMinXValue()
{
  return GetMinValue(0); // 0 - x, 1 - y, 2 - z;
}  

FlpCompFloat TChartSeries::GetMinYValue()
{
  return GetMinValue(1); // 0 - x, 1 - y, 2 - z;
}  

Int32 TChartSeries::GetPointIndexOfXValue(TPointVal *pointval)
{
  TSeriesPoint *temp;
  Int32 count, i;
  
  count = Points->Count();
  for (i = 0; i < count; ++i){
    temp = (TSeriesPoint *)Points->Item(i);
	if (XasDate){
	  if (CompareMyDate(&pointval->asDate, &temp->XValue.asDate) == 0) return i;
	}
	else 
    if (pointval->asFloat.f == temp->XValue.asFloat.f) return i;
  }
  return -1;
}

Int32 TChartSeries::GetPointIndexOfYValue(TPointVal *pointval)
{
  TSeriesPoint *temp;
  Int32 count, i;
  
  count = Points->Count();
  for (i = 0; i < count; ++i){
    temp = (TSeriesPoint *)Points->Item(i);
	if (XasDate){
	  if (CompareMyDate(&pointval->asDate, &temp->YValue.asDate) == 0) return i;
	}
	else 
    if (pointval->asFloat.f == temp->YValue.asFloat.f) return i;
  }
  return NULL;
}