#ifndef TChartSeries_h
#define TChartSeries_h 1
#include <PalmOS.h> 
#include "TList.hpp" 
#include "CommonFunc.hpp" 

class TChart;
class TChartSeries;
//     
//struct TSeriesPoint;
typedef union TPointVal{
   FlpCompFloat asFloat;
   MyDateType   asDate;
} TPointVal;

class TSeriesPoint
{
  public:
      TSeriesPoint(TChartSeries *owner);
	  TSeriesPoint();
      union TPointVal XValue;
	  union TPointVal YValue;
    /*union {
	  FlpCompFloat asFloat;
	  MyDateType   asDate;
    } YValue;*/
  FlpCompFloat GetXValueAsFloat(Boolean isDate);	
  FlpCompFloat GetYValueAsFloat(Boolean isDate);	
  FlpCompFloat GetXValueAsFloat();	
  FlpCompFloat GetYValueAsFloat();	
  Char *GetXValueAsString(Char *p);
  Char *GetYValueAsString(Char *p);
  
  TChartSeries *Owner;
};

/*typedef struct TSeriesPoint{
         union {
		   FlpCompFloat asFloat;
		   MyDateType   asDate;
               } XValue;
         union {
		   FlpCompFloat asFloat;
		   MyDateType   asDate;
               } YValue;
} TSeriesPoint;*/ 
 
class TChartSeries 
{
  public:
	  TChartSeries(TChart *owner, Char *name);

      TChartSeries(const TChartSeries &right);

      ~TChartSeries();

      TChartSeries & operator=(const TChartSeries &right);

      int operator==(const TChartSeries &right) const;

      int operator!=(const TChartSeries &right) const;
      
      Int32 PointsCount(); //    
	  TSeriesPoint *Point(Int32 index); //     
	  Int32 AddPoint(TSeriesPoint point); //  
	  
      FlpCompFloat GetMaxXValue();
      FlpCompFloat GetMaxYValue();
      FlpCompFloat GetMinXValue();
      FlpCompFloat GetMinYValue();
	  Int32 GetPointIndexOfXValue(TPointVal *pointval);
	  Int32 GetPointIndexOfYValue(TPointVal *pointval);
	  
	  void set_XasDate(Boolean value);
	  const Boolean get_XasDate(void) const;
	  void set_YasDate(Boolean value);
	  const Boolean get_YasDate(void) const;
	  
	  Char Name[20];
	  Int32 CondID; // ID     .  
  protected:
  private:
	  FlpCompFloat GetMaxValue(UInt8 xyz); // 0 - x, 1 - y, 2 - z
	  FlpCompFloat GetMinValue(UInt8 xyz); // 0 - x, 1 - y, 2 - z
	  TChart *Owner;
      TList *Points;  //  
	  Boolean XasDate, YasDate;  //    X  Y  
  private: 
};
inline void TChartSeries::set_XasDate(Boolean value)
{
  XasDate = value;
}
inline const Boolean TChartSeries::get_XasDate(void) const
{
  return XasDate;
}
inline void TChartSeries::set_YasDate(Boolean value)
{
  YasDate = value;
}
inline const Boolean TChartSeries::get_YasDate(void) const
{
  return YasDate;
}

#endif
