#include <PalmOS.h>
#include "TDBGrid.hpp"

static TDBGrid *ArrDBGrids[20];
static UInt8 DBGridsCount = 0;


// Class TDBGrid 
TDBGrid::TDBGrid()
{
}

TDBGrid::TDBGrid(const TDBGrid &right)
{
}

// 
TDBGrid::TDBGrid (ScrollBarPtr pscrollbar, TablePtr ptable, TDataSet *dataset)
{
	PScrollBar = pscrollbar;
    PTable = ptable; 
	DataSet = dataset;	
	ColumnCount = 0;
	//MaxColCount = TblGetNumberOfColumns(PTable);
	MaxColCount = cMaxColCount;
	MaxRowCount = TblGetNumberOfRows(ptable);
	StartPos = 0;
	DSRecCount = 0;
	//   TDBGrid,     loadProc
    ArrDBGrids[DBGridsCount] = this;
	++DBGridsCount;
}


TDBGrid::~TDBGrid()
{	int i;
	Boolean found;
	
	found = false;
	for(i = 0; i < DBGridsCount; ++i){
		if ((!found) && (ArrDBGrids[i] == this)) found = true;
		if (found) ArrDBGrids[i] = ArrDBGrids[i+1]; 
	}
	--DBGridsCount;
}


TDBGrid & TDBGrid::operator=(const TDBGrid &right)
{
}


int TDBGrid::operator==(const TDBGrid &right) const
{
}

int TDBGrid::operator!=(const TDBGrid &right) const
{
}


//## Other Operations (implementation)
void TDBGrid::AddColumn (TField *field, 	// :
  TableItemStyleType itemtype, 
  TableLoadDataFuncPtr loadDataCallback = NULL)
{
	if (MaxColCount > ColumnCount){
	  //StrPrintF(columns[ColumnCount].field.FieldName, "%s", fieldname);
	  columns[ColumnCount].itemtype = itemtype;
	  columns[ColumnCount].field = field;
	  //columns[ColumnCount].DataLen = datalen;
	  //columns[ColumnCount].enabled = enabled;
	  columns[ColumnCount].loadDataCallback = loadDataCallback;
	  ColumnCount++;
	}else
	{
		SysFatalAlert ("    .");  
	}
}

/*void TDBGrid::AddColumnByField (Char fieldname[30], TableItemStyleType itemtype,
  Boolean enabled, 
  TableLoadDataFuncPtr loadDataCallback = NULL)
{
    TField field;
	
	field = DataSet->GetFieldByName(fieldname);
    AddColumn(fieldname, itemtype, field.fieldtype, field.DataLen,
      enabled, loadDataCallback);	
}*/

void TDBGrid::Refresh(void)
{  int i, j;

//       textTableItem(  loadProc)
	  // ----   
	  if (!DataSet->get_Active()) return;
	  i = DataSet->RecCount();
	  if (DSRecCount != i) {
        /*if (i < MaxRowCount) //       
          SclSetScrollBar (PScrollBar, 0, 0, 0, 0);
	    else
          SclSetScrollBar (PScrollBar, StartPos, 0, i - (MaxRowCount - 1), MaxRowCount - 1); // +1 -  -    */
		DSRecCount = i;
        InitGrid();		  
	  }  

      for(i = 0; i < ColumnCount; ++i){ //    
	    TField *field = columns[i].field;
		switch (columns[i].itemtype){
   		  case labelTableItem  : {
		    for(j = 1; j < (UseRowCount + 1); ++j){
              Char *ptr;
			  ptr = (Char *)TblGetItemPtr (PTable, j, i);
			  DataSet->set_Position(j - 1 + StartPos);
			  ptr = field->DS->FieldAsPChar(field, ptr);
              TblSetItemPtr(PTable, j, i, ptr);
			}
		    break;	
		  }
    	  case checkboxTableItem : {
		    for(j = 1; j < (UseRowCount + 1); ++j){
			  Int16 lInt16;
			  Int8 *lInt;
			  
			  DataSet->set_Position(j - 1 + StartPos);
			  
			  lInt = (Int8 *)field->DS->GetFieldData(field);
			  lInt16 = *lInt; 
			  TblSetItemInt(PTable, j, i, lInt16);
			}
		    break;	
		  }
		  
          default:;
        }
      }
  	  TblDrawTable(PTable);
      DataSet->set_Position(StartPos);  
} 

//     CheckBox' 
Boolean TDBGrid::tblSelectEventHandler(EventPtr event)
{  int i, j;
   //Char mess[50];
  //  
  //prevPos = event->data.sclExit.value;
  for(i = 0; i < ColumnCount; ++i){ //    
    TField *field = columns[i].field;
	switch (columns[i].itemtype){
   	  case checkboxTableItem : {
	    for(j = 1; j < (UseRowCount + 1); ++j){
		  Boolean val;
		  DataSet->set_Position(j - 1 + StartPos);
		  val = TblGetItemInt(PTable, j, i) != 0;
		  //StrPrintF(mess, " '%i'", (Int8)val);
		  //SysFatalAlert (mess);
		  
		  if (field->DS->SetFieldData(field, (Char *)&val, true)){
		  //if (!field.DS->SetFieldData(&field, p, true)){
	        SysFatalAlert ("   checkboxTableItem.");  
		  }
		}
	    break;	
	  }
	  
      default:;
    }
  }
  DataSet->set_Position(StartPos);  
}

Boolean TDBGrid::sclExitEventHandler(EventPtr event)
{  int i, j;
   int prevPos;
 
	if ((event != NULL)&&(StartPos != event->data.sclExit.newValue))
	{  
   	  StartPos = event->data.sclExit.newValue;
	  //       textTableItem(  loadProc)
      Refresh();	  
	}  
	return true;
}	

//   
Boolean TDBGrid::keyDownEventHandler(EventPtr event){
	Int16 valueP, minP, maxP, pageSizeP;

	if ((event->data.keyDown.chr == 11)||
	    (event->data.keyDown.chr == 12)){
		SclGetScrollBar (PScrollBar, &valueP, &minP, &maxP, &pageSizeP);
	    if (event->data.keyDown.chr == 11) 
		     valueP = valueP - pageSizeP;
		else valueP = valueP + pageSizeP;
		
		if (valueP < 0)  valueP = 0; 
		if (valueP > (maxP))  valueP = maxP;
		SclSetScrollBar (PScrollBar, valueP, minP, maxP, pageSizeP);
	  if (valueP != StartPos){ 	
        StartPos = valueP;
        Refresh();
	  }		  
	}
}



//    .      . 
//      .
static Boolean saveProc(void *tableP, Int16 row, Int16 column)
{
   SysFatalAlert ("   .");  
   return true;
}
//    
static Err loadProc(void *tableP, Int16 row, Int16 column, Boolean editable, 
            MemHandle * dataH, Int16 *dataOffset, Int16 *dataSize, FieldPtr fld)
{   TDBGrid *DBGrid, *lDBGrid;
	//UInt32 readpos, colcount;
	int i;
   
    //          
    // ,     .   .
    //    .
	//UInt32 *amt;
	DBGrid = NULL;
	//   Grid'a
	for(i = 0; i < DBGridsCount; ++i){
		lDBGrid = ArrDBGrids[i];
		if (lDBGrid->PTable == tableP){
			DBGrid = lDBGrid;
			break;
		}  
	}
	if (DBGrid == NULL) {
		SysFatalAlert ("       DBGrid.");
		return dmErrCantOpen;  
	}
	
	if ( DBGrid->DataSet->RecCount() > (row - 1+ DBGrid->StartPos)) 
	{ 
  		    TField *field;
			field = (DBGrid->columns[column].field);
			DBGrid->DataSet->set_Position(row - 1 + DBGrid->StartPos);
			
			//  
			{
              MemHandle h;
  			  Char *p;
			  
  			  if (field->fieldtype == fdtChar){
			    h = field->DS->GetFieldDataHandle(field, &p);
				if (!h) {
  	              h = MemHandleNew(1);
	              p = (Char *) MemHandleLock(h);
	              p[0] = 0;
                  MemHandleUnlock(h);
  			      *dataOffset = 0;
				} else *dataOffset = field->get_offset();

				
			  }
			  else{
  			  //if ((field.fieldtype == fdtInt)||(field.fieldtype == fdtCurrency)){
				h = MemHandleNew(30);
				p = (Char *)MemHandleLock(h);
					
				p = field->DS->FieldAsPChar(field, p);
				MemHandleUnlock(h);
			    *dataOffset = 0;
			  }
			  *dataSize = StrLen(p);
			  if (!h) 
		        SysFatalAlert ("    Handle = NULL.");
			  *dataH = h;
			}
  	}
	else
	{
		MemHandle h;
		char *p;
		const int size = 30;
		h = MemHandleNew(size);
		p = (char *)MemHandleLock(h);
   	   	StrIToA(p, row + DBGrid->StartPos);
		MemHandleUnlock(h);
		*dataH = h;
		*dataOffset = 0;
	    *dataSize = size;
	}
    return errNone;          
}

//    
static void drawProc(void *tableP, Int16 row, Int16 column, 
  RectangleType *bounds)
{   TDBGrid *DBGrid, *lDBGrid;
	int i;
   
	DBGrid = NULL;
	//   Grid'a
	for(i = 0; i < DBGridsCount; ++i){
		lDBGrid = ArrDBGrids[i];
		if (lDBGrid->PTable == tableP){
			DBGrid = lDBGrid;
			break;
		}  
	}
	if (DBGrid == NULL) {
		SysFatalAlert ("       DBGrid.");
		return;  
	}
	
      //     
      Int16 y = bounds->topLeft.y + (bounds->extent.y - FntCharHeight()) / 2;
      RectangleType r;
      if (row != 0){
  		TField *field = (DBGrid->columns[column].field);
		DBGrid->DataSet->set_Position(row - 1 + DBGrid->StartPos);
	  
        Char *ptr;
        ptr = (Char *)MemPtrNew(30);
		ptr = field->DS->FieldAsPChar(field, ptr);
        //StrPrintF(ptr, "%s", columns[j].FieldName);
        WinDrawTruncChars(ptr, StrLen(ptr), 
		  bounds->topLeft.x + 2, y, bounds->extent.x);
		MemPtrFree(ptr);  
      }
	  else
      //      
	  {
        WinDrawTruncChars(DBGrid->columns[column].field->FieldName, 
	      StrLen(DBGrid->columns[column].field->FieldName), 
		  bounds->topLeft.x + 2, y, bounds->extent.x);
        r = *bounds;
        RctInsetRectangle(&r, 1);
        WinDrawRectangleFrame(rectangleFrame, &r);
	  }
}




void TDBGrid::InitGrid(void)
{
      UInt16  i, j;
  	  //FormPtr form;
	  //TableLoadDataFuncPtr loadDataCallback;

	  //loadDataCallback = loadProc;
	  //  
	  DataSet->Open();
	  i = DataSet->RecCount();
	  StartPos = 0;
	  // ----   
      if (i < MaxRowCount) //       
        SclSetScrollBar (PScrollBar, 0, 0, 0, 0);
	  else
        SclSetScrollBar (PScrollBar, 0, 0, i - (MaxRowCount - 1), MaxRowCount - 1); // +1 -  -    
  	  DSRecCount = i;  
      //   
	  if (i < (MaxRowCount - 1)) UseRowCount = i;
	  else UseRowCount = MaxRowCount - 1;
	  
	  //cols = GetUseColCount(); //   
	  	  

      //    
      for(i = 0; i < MaxRowCount; ++i){
         TblSetRowUsable(PTable, i, i < (UseRowCount + 1)); //+1  
		 TblSetRowStaticHeight (PTable, i, true); 
      }

      //    
      //      2 
      for(j = 0; j < ColumnCount; ++j){
            TblSetColumnUsable(PTable, j, true);
            TblSetColumnSpacing(PTable, j, 2);
      }
      //      
      for(i = 0; i < ColumnCount; ++i){
            TblSetItemStyle(PTable, 0, i, customTableItem);
            TblSetCustomDrawProcedure(PTable, i, drawProc);
      }
        //    
		for(i = 1; i < (UseRowCount + 1); ++i){
		  DataSet->set_Position(i - 1);
		  for (j = 0; j < ColumnCount; ++j){
		    TField *field = columns[j].field;
			
			TblSetItemStyle(PTable, i, j, columns[j].itemtype);
			switch (columns[j].itemtype){
        		case textTableItem : {
				  if (columns[j].loadDataCallback == NULL){
					TblSetLoadDataProcedure(PTable, j, loadProc);
					if (field->Editable)
  					  TblSetSaveDataProcedure(PTable, j, saveProc);
				  }	
				  else
					TblSetLoadDataProcedure(PTable, j, columns[j].loadDataCallback);
				  break;	
				}
					
       			case labelTableItem : {
                  Char *ptr;
                  ptr = (Char *)MemPtrNew(field->get_DataLen());
				  ptr = field->DS->FieldAsPChar(field, ptr);
                  //StrPrintF(ptr, "%s", columns[j].FieldName);
                  TblSetItemPtr(PTable, i, j, ptr);
				  break;	
				}
       			case customTableItem : {
                  TblSetCustomDrawProcedure(PTable, j, drawProc);
				  break;	
				}
       			case checkboxTableItem : {
			      Int16 lInt16;
			      Int8 *lInt;
				  lInt = (Int8 *)field->DS->GetFieldData(field);
				  lInt16 = *lInt; 
			      TblSetItemInt(PTable, i, j, lInt16);
				  break;	
				}

         		default:;
        	}
		  }
		}	
}
// Additional Declarations
