#ifndef TDataSet_h
#define TDataSet_h 1


#include "TField.hpp"
#include "Sections.hpp"

#define MaxFields 30
enum TEqType { etMore, etLess, etEqual, etNotEqual, etEMore, etELess};
enum TDataSetState { dsInsert, dsBrowse, dsFilter};

class TDataSet;
//   
/*struct TField{
      Char FieldName[30]; 
      TFldDataType fieldtype; 	//  :
	  UInt16 DataLen;           //  
	  UInt16 offset;            //      
	  TDataSet *DS;
	  Boolean isMemFld;      //          ,   Open(),   Close()
	  Boolean Editable;      //  
	  Char *MemData;         //        
	  };*/
//  	(  )  
//struct TFilterMemb *PFilterMemb;
struct TFilterMemb{
      TField *field;  //     
	  Char *data;    //    
	  TEqType EqType; //   "data"    
	  TFilterMemb *next;  
};


//Err FuncValidateRecType(TDataSet *ds);
//FuncValidateRecType *FuncValidateRecTypePtr; 


class TDataSet 
{
  public:
    //## Constructors (generated)
      TDataSet();

      TDataSet(const TDataSet &right);

    //## Destructor (generated)
      ~TDataSet();

    //## Assignment Operation (generated)
      TDataSet & operator=(const TDataSet &right);

    //## Equality Operations (generated)
      int operator==(const TDataSet &right) const;

      int operator!=(const TDataSet &right) const;


    //## Other Operations (specified)
      //## Operation: Open%3F7C29B500E1
      Err Open (const DmOpenRef adbPtr=NULL);

      //## Operation: RecCount%3F7C29BD0179
      UInt32 RecCount ();

      //## Operation: Close%3F7C2A2E0322
      void Close ();

      //## Operation: Drop%3F7C2A3902B0
      void Drop ();

      //## Operation: Clear%3F7C2A5C015D
      void Clear ();
	  
      Err CreateDB ();
	  //  
	  Boolean Insert();
      Boolean DBExists();
	  
	  
	  
      MemHandle GetRecHandle (UInt16 Index);
	  
      TField* AddField(Char fieldname[30], 
    	TFldDataType fieldtype, 	//  :
		UInt32 datalen); //  
		
	  //          ,   Open(),   Close()	  
      TField* AddMemField (Char fieldname[30], 
    	TFldDataType fieldtype, 	//  :
		UInt32 datalen); //  
		
	  //        fldSize  	  
      TField* AddFloatSizeField (Char fieldname[30], 
    	TFldDataType fieldtype, 	//  :
		TField *fldSize); 
		
      //     
      UInt8 GetMemFldCount();


      //## Attribute: DB_NAME%3F7C246100ED
      const Char get_DB_NAME () const;
      void set_DB_NAME (Char *value);
	  
      //## Attribute: DB_CARDNO%3F7C249B025A
      const UInt32 get_DB_CARDNO () const;
      void set_DB_CARDNO (UInt32 value);

      //## Attribute: DB_CREATOR%3F7C24A90246
      const Char get_DB_CREATOR () const;
      void set_DB_CREATOR (Char *value);

      //## Attribute: Active%3F7C2AF201D4
      const UInt16 get_Position () const;
      void set_Position (UInt16 value);
	  
      const TDataSetState get_State () const;
	  
      const Boolean get_Active () const;
      void set_Active (Boolean value);

      const UInt16 get_FieldCount() const;
	  
	  Boolean LocateByField(TField *field, Char *data);
	  
	  
	  //Char* GetFieldDataByName(Char fieldname[30],  const Boolean positing=true);
      Char* GetFieldData(TField *field, const Boolean positing=true);
      Err SetFieldData(TField *field, Char *p, const Boolean positing=true);
	  
	  

      MemHandle GetFieldDataHandle(TField *field, Char **p);
	  
	  
	  TField *GetFieldByName(Char fieldname[30]);
	  
	  Char* FieldAsPChar(TField *field, Char *p);
	  
	  Boolean SetLinkDS(TField *linkDSField, TField *linkField);
      Boolean ClearLink(void);
	  
	  
      const DmOpenRef get_dbPtr () const;
      void set_dbPtr (DmOpenRef value);
	  
	  TFilterMemb* AddFilterMemb(TField *afield, Char *adata, TEqType aEqType);
	  //   
	  //struct TField fields[MaxFields];
	  struct TField *fields[MaxFields];
	  
	  //
	  struct TFilterMemb *FilterMembs; //     
	  
	  UInt32 CountFltMemb; //   
      const Boolean get_Filtered () const;
      //void set_Filtered (Boolean value);
	  void set_Filtered (Boolean value);
	  //Boolean OnFiltered(Boolean filtered); 
	  //void *OnFuncValidateRecType;
	  //       
	  Boolean (*OnFuncValidateRecType)(TDataSet *dataset);
	   
      const Boolean get_HasFloatSizeFld() const;
      Boolean Filtered;  
  protected:
    // Additional Protected Declarations
      //## begin TDataSet%3F7C244D0378.protected preserve=yes
      //## end TDataSet%3F7C244D0378.protected

  private:
      //  DataSet         pos  
      UInt16 GetFilterPos(UInt16 pos);
	  Boolean LinkPositioning(); //    TDataSet
	  UInt16 *FilteredRecs; //     
	  Int32 FltRecCount; //   
	  Boolean HasFloatSizeFld; //        

      //## Attribute: dbPtr%3F7C24EA03DB
	  
    // Additional Private Declarations
      //## begin TDataSet%3F7C244D0378.private preserve=yes
      //## end TDataSet%3F7C244D0378.private

  private: //## implementation
      Char *DB_NAME;
      UInt32 DB_CARDNO;
      Char *DB_CREATOR;
      DmOpenRef dbPtr;
	  UInt16 Position;   //  
	  UInt16 FieldCount; //  MaxColCount
	  Boolean MyDBPtr; //     dbPtr  
	  
	  TDataSetState State;
	  
	  TDataSet *LinkDS; //   (Parent)
	  TField *LinkDSField; //      
	  TField *LinkField; //      LinkDSFieldName
};

//## begin TDataSet%3F7C244D0378.postscript preserve=yes
//## end TDataSet%3F7C244D0378.postscript

// Class TDataSet 

//## Get and Set Operations for Class Attributes (inline)

inline const Char TDataSet::get_DB_NAME () const
{
  return *DB_NAME;
}

inline void TDataSet::set_DB_NAME (Char *value)
{
  DB_NAME = value;
}

inline const UInt32 TDataSet::get_DB_CARDNO () const
{
  return DB_CARDNO;
}

inline void TDataSet::set_DB_CARDNO (UInt32 value)
{
  DB_CARDNO = value;
}

inline const Char TDataSet::get_DB_CREATOR () const
{
  return *DB_CREATOR;
}

inline void TDataSet::set_DB_CREATOR (Char *value)
{
  DB_CREATOR = value;
}

inline const DmOpenRef TDataSet::get_dbPtr () const
{
  return dbPtr;
}

inline void TDataSet::set_dbPtr (DmOpenRef value)
{
  dbPtr = value;
  MyDBPtr = false;
}

inline const Boolean TDataSet::get_Active () const
{
  return dbPtr!=NULL;
}

inline void TDataSet::set_Active (Boolean value)
{
  if (value) Open();
  else Close();
}

inline const Boolean TDataSet::get_Filtered () const
{
  return Filtered;
}

/*inline void TDataSet::set_Filtered (Boolean value)
{
  OnFiltered(value);  
}*/


inline const UInt16 TDataSet::get_Position () const
{
  return Position;
}

inline const UInt16 TDataSet::get_FieldCount () const
{
  return FieldCount;
}

inline const Boolean TDataSet::get_HasFloatSizeFld() const
{
  return HasFloatSizeFld;
}
inline const TDataSetState TDataSet::get_State() const
{
  return State;
}

#endif
