#ifndef TDateEdit_h
#define TDateEdit_h 1
#include <PalmOS.h> 
#include "CommonFunc.hpp" 

//	 
class TDateEdit 
{
  public:
    //## Constructors (generated)
      TDateEdit(const TDateEdit &right);

    //## Constructors (specified)
      //## Operation: TDateEdit%3FA0D1BB0058
      TDateEdit (FieldPtr aPField	//  
      );

    //## Destructor (generated)
      ~TDateEdit();

    //## Assignment Operation (generated)
      TDateEdit & operator=(const TDateEdit &right);

    //## Equality Operations (generated)
      int operator==(const TDateEdit &right) const;

      int operator!=(const TDateEdit &right) const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: Text%3FA0D20F01A5
      const Char* get_Text () const;
      void set_Text (const Char* value);

      void set_date (Int8 aday, Int8 amonth, Int8 ayear);
	  
      //## Attribute: day%3FA0D2FF0336
      const Int8 get_day () const;
      void set_day (Int8 value);

      //## Attribute: month%3FA0D304013E
      const Int8 get_month () const;
      void set_month (Int8 value);

      //## Attribute: year%3FA0D30800CC
      const Int8 get_year () const;
      void set_year (Int8 value);
	  
      const MyDateType get_Date () const;
      void set_Date (MyDateType value);
	  
	  

    // Additional Public Declarations
      //## begin TDateEdit%3FA0D17000F9.public preserve=yes
      //## end TDateEdit%3FA0D17000F9.public
	  void DateToField(void); //    
	  
      Boolean OnfldEnter(EventPtr event); //      "fldEnterEvent"
	  
	  	     
  protected:
    // Additional Protected Declarations
      //## begin TDateEdit%3FA0D17000F9.protected preserve=yes
      //## end TDateEdit%3FA0D17000F9.protected

  private:
    // Additional Private Declarations
      //## begin TDateEdit%3FA0D17000F9.private preserve=yes
      //## end TDateEdit%3FA0D17000F9.private
	  

  private: //## implementation
      Char Text[10];
      FieldPtr PField;
	  MyDateType Date;	  

};

//## begin TDateEdit%3FA0D17000F9.postscript preserve=yes
//## end TDateEdit%3FA0D17000F9.postscript

// Class TDateEdit 

//## Get and Set Operations for Class Attributes (inline)

inline const Char* TDateEdit::get_Text () const
{
  //## begin TDateEdit::get_Text%3FA0D20F01A5.get preserve=no
  return Text;
  //## end TDateEdit::get_Text%3FA0D20F01A5.get
}

inline void TDateEdit::set_Text (const Char* value)
{
  //## begin TDateEdit::set_Text%3FA0D20F01A5.set preserve=no
  StrCopy((Char *)&Text, value);
  //## end TDateEdit::set_Text%3FA0D20F01A5.set
}

inline const Int8 TDateEdit::get_day () const
{
  //## begin TDateEdit::get_day%3FA0D2FF0336.get preserve=no
  return Date.day;
  //## end TDateEdit::get_day%3FA0D2FF0336.get
}

inline void TDateEdit::set_day (Int8 value)
{
  //## begin TDateEdit::set_day%3FA0D2FF0336.set preserve=no
  Date.day = value;
  //## end TDateEdit::set_day%3FA0D2FF0336.set
}

inline const Int8 TDateEdit::get_month () const
{
  //## begin TDateEdit::get_month%3FA0D304013E.get preserve=no
  return Date.month;
  //## end TDateEdit::get_month%3FA0D304013E.get
}

inline void TDateEdit::set_month (Int8 value)
{
  //## begin TDateEdit::set_month%3FA0D304013E.set preserve=no
  Date.month = value;
  //## end TDateEdit::set_month%3FA0D304013E.set
}

inline const Int8 TDateEdit::get_year () const
{
  //## begin TDateEdit::get_year%3FA0D30800CC.get preserve=no
  return Date.year;
  //## end TDateEdit::get_year%3FA0D30800CC.get
}

inline const MyDateType TDateEdit::get_Date () const
{
  //## begin TDateEdit::get_year%3FA0D30800CC.get preserve=no
  return Date;
  //## end TDateEdit::get_year%3FA0D30800CC.get
}

inline void TDateEdit::set_year (Int8 value)
{
  //## begin TDateEdit::set_year%3FA0D30800CC.set preserve=no
  Date.year = value;
  //## end TDateEdit::set_year%3FA0D30800CC.set
}

//## begin module%3FA0D17000F9.epilog preserve=yes
//## end module%3FA0D17000F9.epilog


#endif
