
#include <PalmOS.h>
#include "FinDiagrCPP.hpp"
#include "FinDiagrCPP_res.hpp"
#include "FinDataModule.hpp"
#include "frmChart.hpp"
   
TChart *Chart = NULL;
FormPtr PfrmChart;

void ReturnTofrmChartAfter_frmCond(Boolean result){
  UInt16 i, RecCount;
  Int32 PointCount;// DaysCount, ;
  MyDateType *maxDate, *minDate, *PcurDate, curDate;
  TSeriesPoint point;
  Boolean isMonth;
  RectangleType rm;
  
  
  
  FrmSetActiveForm(PfrmChart);
  rm.topLeft.x = 0; 
  rm.topLeft.y = 0;
  rm.extent.x = 160; 
  rm.extent.y = 160;
  WinSetForeColor (0);
  WinDrawRectangle (&rm, 0);
	
  		
  //  
  if (result){
    TChartSeries *series;
	Boolean *pisMonth;
	Char *name; 
	Int32 *CondID;
	
    if (DSTrans->get_Filtered()) SetTransFiltered(false);
    SetTransFiltered(true);
	
    pisMonth = (Boolean *)DSCond->GetFieldData(DSCond->GetFieldByName(""), false);
	isMonth = *pisMonth;
	name = (Char *)DSCond->GetFieldData(DSCond->GetFieldByName(""), false);
	CondID = (Int32 *)DSCond->GetFieldData(DSCond->GetFieldByName("ID"), false);
	
	series = Chart->AddSeries(name);
	series->set_XasDate(true);
	RecCount = DSTrans->RecCount();
	//DSTrans->set_Position(0);
	//maxDate = (MyDateType *)DSTrans->GetFieldData(DSTrans->GetFieldByName(""), false);
	series->CondID = *CondID;
	DSTrans->set_Position(0);
	maxDate = (MyDateType *)DSTrans->GetFieldData(DSTrans->GetFieldByName(""), false);
	minDate = maxDate;
	
    for(i = 0; i < RecCount; ++i){
  	  DSTrans->set_Position(i);
	  
	  PcurDate = (MyDateType *)DSTrans->GetFieldData(DSTrans->GetFieldByName(""), false);
      if (CompareMyDate(PcurDate, maxDate) > 0){
	    maxDate = PcurDate;
	  }
      if (CompareMyDate(PcurDate, minDate) < 0){
	    minDate = PcurDate;
	  }
    }
	//   
    if (isMonth) PointCount = MonthsBeetwin(minDate, maxDate)+1;
	else PointCount = DaysBeetwin(minDate, maxDate);
	  
    curDate = *minDate;
    if (isMonth) curDate.day = 0;
	
    ProgressBar->Start(0, PointCount + RecCount, " ");
	//            
    for(i = 0; i < PointCount; ++i){
	  point.XValue.asDate = curDate;
	  //MemMove (&point.XValue.asDate, PcurDate, sizeof(MyDateType));
      if (isMonth) MonthAdjust(&curDate, 1);
	  else DayAdjust(&curDate, 1);
	  
	  point.YValue.asFloat.f = 0;
	  series->AddPoint(point);
	  ProgressBar->Progress();
	}
	DSCurr->Open();
	//       
    for(i = 0; i < RecCount; ++i){
	  FlpCompFloat *amt;
	  TPointVal *Ppointval;
	  TPointVal pointval;
	  Int32 index;
      TSeriesPoint *Ppoint;
	  
	  
  	  DSTrans->set_Position(i);
	  amt = (FlpCompFloat *)DSTrans->GetFieldData(DSTrans->GetFieldByName(""), false);
	  /*if (i == 82){
	    MyDateType *date; 
	    SysFatalAlert(" ");
		DSTrans->Filtered = false;
    	DSTrans->set_Position(1920);
	    date = (MyDateType *)DSTrans->GetFieldData(DSTrans->GetFieldByName(""), false);
		DSTrans->Filtered = true;
	  }*/
	  Ppointval = (TPointVal *)DSTrans->GetFieldData(DSTrans->GetFieldByName(""), false);
	  pointval = *Ppointval;
      if (isMonth) pointval.asDate.day = 0;
	  index = series->GetPointIndexOfXValue(&pointval);
	  if (index < 0)
	    SysFatalAlert(" ");
	  else{
	    Boolean *FOWNCURRENCY;
		FlpCompFloat *rate;
  	    Ppoint = series->Point(index);
		
		FOWNCURRENCY = (Boolean *)DSTrans->GetFieldData(DSTrans->GetFieldByName("FOWNCURRENCY"), false);
		if (!(*FOWNCURRENCY)) //   
		  rate = (FlpCompFloat *)DSCurr->GetFieldData(DSCurr->GetFieldByName("RATE"));
		else //  
  		  rate = (FlpCompFloat *)DSTrans->GetFieldData(DSTrans->GetFieldByName("CURRENCY_RATE"), false);
		
        Ppoint->YValue.asFloat.f = Ppoint->YValue.asFloat.f + amt->f*rate->f ;
	    //Ppoint->YValue.asFloat.f = amt->f + Ppoint->YValue.asFloat.f;
		
	  }	
	  ProgressBar->Progress();
	}
	
    ProgressBar->Finish();
	
  }
  Chart->Redraw();  
  FrmDrawForm(PfrmChart);
}

Boolean frmChart_Initialize(void)
{
  if (Chart == NULL) Chart = new TChart(DSSeries, DSPoints);
  
  if (!Chart->Load(ProgressBar)){
	FrmPopupForm(frmCond);
    return false;
  } else{
    Chart->Redraw();
  }	  
  
}

Boolean frmChart_ReleaseData(){
  if (Chart) delete Chart;
  Chart = NULL; 
}

Boolean frmChart_HandleEvent(EventPtr event)
{
	//FormPtr form;
	Boolean handled = false;
	
	if (Chart) Chart->Event_Handler(event);
	switch (event->eType)
	{
		case frmCloseEvent:
			// Insert code when form closes:
            //SysFatalAlert ("frmChart");
		    frmChart_ReleaseData();
			break;
		case frmOpenEvent:
			// Repaint form on open
			PfrmChart = FrmGetActiveForm();
			FrmDrawForm(PfrmChart);
		    InitDataSets();
			frmChart_Initialize();
			handled = true;
			break;
		default:
			break;
	}

	return handled;
}
