//   
#include <PalmOS.h>
#include "FinDiagrCPP.hpp"
#include "FinDiagrCPP_res.hpp"
#include "TDBGrid.hpp"
#include "TDataSet.hpp"
#include "TProgressBar.hpp"
#include "TDateEdit.hpp"
#include "TComboBox.hpp"
#include "FinDataModule.hpp"
#include "frmChart.hpp"

//   
TDBGrid *DBGridTo = NULL;
TDBGrid *DBGridFr = NULL;
TDBGrid *DBGridCond = NULL;

TDateEdit *DateEditFr = NULL;
TDateEdit *DateEditTo = NULL;

TComboBox *ComboBoxFr = NULL;
TComboBox *ComboBoxTo = NULL;

//Char *txtFrCount = NULL;
//Char *txtToCount = NULL;

FormPtr formCond = NULL;


/*TField *fldCondID, *fldDateFr, *fldDateTo, *fldAccsFrSize, *fldAccsToSize, *fldisMonth,
  *FrAccNums, *ToAccNums, *fldCheckFr, *fldCheckTo, *fldAccNameTo, *fldAccNameFr,
  *fldActiveFr, *fldActiveTo, *fldTotalFr, *fldTotalTo;*/

UInt16 GetSelCount(TDataSet *DS, TField *fldCheck)
{
  UInt16 pos, i, result;
  UInt32 recCount;
	
  pos = DS->get_Position();
  recCount = DS->RecCount();
  result = 0;
  for(i = 0; i < recCount; ++i){
    Int8 *val;
    DS->set_Position(i);
	val = (Int8 *)DS->GetFieldData(fldCheck, false);
    if (*val == 1) ++result; 
  }
  DS->set_Position(pos);
  return result;
}
  
  
//     
Boolean RefreshCountLabels(void){
  ControlType *controlP;
  Char *txtFrCount;
  Char *txtToCount;
  //if (!txtFrCount) txtFrCount = (Char *)MemPtrNew(10);
  //if (!txtToCount) txtToCount = (Char *)MemPtrNew(10);
  
  //StrPrintF(txtFrCount, "%i", GetSelCount(DSAccFr, DSAccFr->GetFieldByName("C")));
  controlP = (ControlType *)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, lblFrCount));
  txtFrCount = (Char *)CtlGetLabel (controlP);
  ClearMem(txtFrCount, 4);
  //StrIToA(txtFrCount, GetSelCount(DSAccFr, DSAccFr->GetFieldByName("C")));
  StrPrintF(txtFrCount, "%i   ", GetSelCount(DSAccFr, DSAccFr->GetFieldByName("C")));
  CtlSetLabel(controlP, txtFrCount);
  FrmShowObject(formCond, FrmGetObjectIndex(formCond, lblFrCount));   
	
  controlP = (ControlType *)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, lblToCount));
  txtToCount = (Char *)CtlGetLabel (controlP);
  ClearMem(txtToCount, 4);
  //StrIToA(txtToCount, GetSelCount(DSAccTo, DSAccTo->GetFieldByName("C")));
  StrPrintF(txtToCount, "%i   ", GetSelCount(DSAccTo, DSAccTo->GetFieldByName("C")));
  CtlSetLabel(controlP, txtToCount);
  FrmShowObject(formCond, FrmGetObjectIndex(formCond, lblToCount));   



  //StrPrintF(txtToCount, "%i", GetSelCount(DSAccTo, DSAccTo->GetFieldByName("C")));
  //CtlSetLabel((ControlType *)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, lblToCount)),
  //  txtToCount);
  
  //FrmDrawForm(formCond);	
  //CtlDrawControl((ControlType *)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, lblToCount)));	
  //CtlDrawControl((ControlType *)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, lblFrCount)));	
}
  
  
void ComboBoxChangeCommon(Int16 aItemIndex, TDBGrid *DBGrid)
{  UInt32 RecCount;
   UInt16 i;
   TField *fldCheck, *fldActive, *fldTotalTo;
   
  fldCheck = DBGrid->DataSet->GetFieldByName("C");
  fldActive = DBGrid->DataSet->GetFieldByName("FACTIVE");
  fldTotalTo = DBGrid->DataSet->GetFieldByName("FTOTAL");
  
  RecCount = DBGrid->DataSet->RecCount();
  for (i=0; i < RecCount; ++i){
    DBGrid->DataSet->set_Position(i);
	Int8 val;
	Int8 *pval;
	Char cval;
	(Char *)pval = DBGrid->DataSet->GetFieldData(fldCheck);
	val = *pval;
    /*C 
       */
    if ((aItemIndex == 0) || (aItemIndex == 1)){
	  val = aItemIndex; 
    }
    /* 2
       3 */
    if ((aItemIndex == 2) || (aItemIndex == 3)){
	  (Char *)pval = DBGrid->DataSet->GetFieldData(fldActive);
	  if (((aItemIndex == 2) && (*pval == 1)) || 
	      ((aItemIndex == 3) && (*pval == 0))){
		val = 1;  
	  }
	}
    /* 4*/
    /*   5*/
    if (aItemIndex == 5){
	  val = !val;
	}
 	DBGrid->DataSet->SetFieldData(fldCheck, (Char *)&val, false);
  }
  DBGrid->Refresh();
  RefreshCountLabels();
}
  
  
//    ComboBoxFr     
void ComboBoxChangeFr(Int16 aItemIndex)
{
  ComboBoxChangeCommon(aItemIndex, DBGridFr);
}
void ComboBoxChangeTo(Int16 aItemIndex)
{
  ComboBoxChangeCommon(aItemIndex, DBGridTo);
}


//        
void SaveArraySelectedAccounts(TDataSet *DSAcc, 
  TField *fldArrSize, //      
  TField *fldArrAccNums) //     
{
  TField *fldCheck, *fldAccID;
  UInt16 selCount; 
  UInt32 floatFldSize;
  UInt32 *ArrAcc;
  
  //    
  fldCheck = DSAcc->GetFieldByName("C");
  fldAccID = DSAcc->GetFieldByName("ID"); 
  //   
  selCount = GetSelCount(DSAcc, fldCheck);
  ArrAcc = (UInt32 *)MemPtrNew(selCount * 4);
  if (selCount > 0){   
    UInt16 pos, i, j;
    UInt32 recCount;
	
    pos = DSAcc->get_Position();
	recCount = DSAcc->RecCount();
	j = 0;  
    for(i = 0; i < recCount; ++i){
	  Int8 *val;
	  DSAcc->set_Position(i);
	  val = (Int8 *)DSAcc->GetFieldData(fldCheck, false);
	  if (*val == 1){
	    UInt32 *acc;
		acc = (UInt32 *)DSAcc->GetFieldData(fldAccID, false); 
	    ArrAcc[j] = *acc; 
	    ++j;
	  } 
	}
    DSAcc->set_Position(pos);
  }
  floatFldSize = selCount * 4;
  DSCond->SetFieldData(fldArrSize, (Char *)&floatFldSize, false);
  DSCond->SetFieldData(fldArrAccNums, (Char *)ArrAcc, false);
  if (selCount > 0) MemPtrFree(ArrAcc);
}

//    
void CondSave(void)
{
  MyDateType date;
  Char *p;
  ControlType *controlP;
  Boolean bval;
  //FormPtr form;
  
  //  
  date = DateEditFr->get_Date();
  p = (Char *)&date;
  DSCond->SetFieldData(DSCond->GetFieldByName(" "), p, false);
  date = DateEditTo->get_Date();
  DSCond->SetFieldData(DSCond->GetFieldByName(" "), p, false);
  
  //form = FrmGetActiveForm();
  controlP = (ControlType *)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, chbisMonth));
  bval = CtlGetValue(controlP);
  DSCond->SetFieldData(DSCond->GetFieldByName(""), (Char *)&bval, false);
  
  //     ""
  SaveArraySelectedAccounts(DSAccFr, DSCond->GetFieldByName("AccsFrSize"), DSCond->GetFieldByName("AccsFr"));   
  SaveArraySelectedAccounts(DSAccTo, DSCond->GetFieldByName("AccsToSize"), DSCond->GetFieldByName("AccsTo"));   
}

//    
void LoadArrSelectedAccounts(TDataSet *DSAcc, 
  TField *fldArrSize, //      
  TField *fldArrAccNums) //     
{
  TField *fldCheck, *fldAccID;
  UInt16 selCount; 
  UInt32 *floatFldSize;
  UInt32 *ArrAcc;
  UInt32 recCount;
  Int8 val, i;
  
  //    
  fldCheck = DSAcc->GetFieldByName("C");
  fldAccID = DSAcc->GetFieldByName("ID"); 
  
  //    
  floatFldSize = (UInt32 *)DSCond->GetFieldData(fldArrSize, false);
  ArrAcc = (UInt32 *)DSCond->GetFieldData(fldArrAccNums, false);
  //   
  recCount = DSAcc->RecCount();
  val = 0;
  for(i = 0; i < recCount; ++i){
    DSAcc->set_Position(i);
	DSAcc->SetFieldData(fldCheck, (Char *)&val, false);
  }	
  //     
  if (*floatFldSize > 0){
	val = 1;
    selCount = *floatFldSize / 4;
    for(i = 0; i < selCount; ++i){
	  UInt32 AccNum;
      UInt32 *acc;
	  
	  AccNum = ArrAcc[i]; //  
	  if (DSAcc->LocateByField(fldAccID, (Char *)&AccNum)) {
        DSAcc->SetFieldData(fldCheck, (Char *)&val, false);
	  }
	} 
  } 
}


//    
void CondLoad(void)
{
  MyDateType *date;
  ControlType *controlP;
  Boolean *bval;
  //FormPtr form;
  Int16 ival;
  
  //  
  if (DSCond->RecCount() == 0) return;
  date = (MyDateType *)DSCond->GetFieldData(DSCond->GetFieldByName(" "), false);
  DateEditFr->set_Date(*date);
  date = (MyDateType *)DSCond->GetFieldData(DSCond->GetFieldByName(" "), false);
  DateEditTo->set_Date(*date);
  
  //form = FrmGetActiveForm();
  controlP = (ControlType *)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, chbisMonth));
  bval = (Boolean *)DSCond->GetFieldData(DSCond->GetFieldByName(""), false);
  ival = (Int16)*bval; 
  CtlSetValue(controlP, ival);
  
  //    
  LoadArrSelectedAccounts(DSAccFr, DSCond->GetFieldByName("AccsFrSize"), DSCond->GetFieldByName("AccsFr"));   
  LoadArrSelectedAccounts(DSAccTo, DSCond->GetFieldByName("AccsToSize"), DSCond->GetFieldByName("AccsTo"));
  DBGridFr->Refresh();
  DBGridTo->Refresh();
  RefreshCountLabels();
}

Int32 GetMaxCondID(){
  Int32 recCount, maxID;
  UInt16 pos, i;
  
  recCount = DSCond->RecCount();
  if (recCount == 0) return 1;
  pos = DSCond->get_Position();
  
  
  maxID = 1;
  for(i = 0; i < recCount; ++i){
	  Int32 *ID;
      DSCond->set_Position (i);
	  ID = (Int32 *)DSCond->GetFieldData(DSCond->GetFieldByName("ID"), false);
	  if (i==0) maxID = *ID;
	  else
	  if (maxID < *ID) maxID = *ID;
  }  
  DSCond->set_Position (pos);
  return maxID;
}

//    
static Boolean frmCond_btnNew_OnSelect(EventPtr event)
{
  //FormPtr form;
  Int8 val;
  UInt32 size = 0;
  int count;
  Char mess[50];
  UInt16 pos;
  Int32 ID;
	
	count = DSCond->RecCount();
    StrPrintF(mess, "%i", count);
	size = 0;
	
    ID = GetMaxCondID() + 1;
	
	DSCond->Insert();
	//      
	
	DSCond->SetFieldData(DSCond->GetFieldByName("ID"), (Char *)&ID, false);
	DSCond->SetFieldData(DSCond->GetFieldByName("AccsFrSize"), (Char *)&size, false);
	DSCond->SetFieldData(DSCond->GetFieldByName("AccsToSize"), (Char *)&size, false);
	DSCond->SetFieldData(DSCond->GetFieldByName(""), mess, false);
	val = 0;
	DSCond->SetFieldData(DSCond->GetFieldByName("C"), (Char *)&val, false);
  //DSCond->set_Position(DSCond->RecCount()-1);
  CondSave();	
  //DBGridCond->InitGrid();
  DBGridCond->Refresh();
  //form = FrmGetActiveForm();
  FrmDrawForm(formCond);
  return true;
}

/*static Boolean frmCond_btnTemp_OnSelect(EventPtr event)
{
	// Insert code for btnTemp
    //CondSave();	
	//FrmPopupForm(frmTrans);
	//CondSave();
	//CondLoad();
	return true;
}*/

Boolean frmCond_ReleaseData()
{
   if (DBGridTo) delete DBGridTo;
   if (DBGridFr) delete DBGridFr;
   if (DBGridCond) delete DBGridCond;
   if (DateEditTo) delete DateEditTo;
   if (DateEditFr) delete DateEditFr;
   if (ComboBoxTo) delete ComboBoxTo;
   if (ComboBoxFr) delete ComboBoxFr;
   DBGridTo = NULL;
   DBGridFr = NULL;
   DBGridCond = NULL;
   DateEditTo = NULL;
   DateEditFr = NULL;
   ComboBoxTo = NULL;
   ComboBoxFr = NULL;
   //if (txtFrCount) MemPtrFree(txtFrCount);
   //if (txtToCount) MemPtrFree(txtToCount);
   //txtFrCount = NULL;
   //txtToCount = NULL;
}

static Boolean frmCond_btnCancel_OnSelect(EventPtr event)
{
    frmCond_ReleaseData();
    FrmReturnToForm (frmChart); 
	ReturnTofrmChartAfter_frmCond(false);
	return true;
}



static Boolean frmCond_btnOk_OnSelect(EventPtr event)
{
    CondSave();	
    frmCond_ReleaseData();
    //FrmReturnToForm (frmCond); 
	ReturnTofrmChartAfter_frmCond(true);
	return true;
}


Boolean AccGetValidRec(TDataSet *dataset)
{
  Boolean *isActive;
  
  //    
  isActive = (Boolean *)dataset->GetFieldData(dataset->GetFieldByName("C"), false);
  ProgressBar->Progress();
  return *isActive;
}

static Boolean frmCond_chbActiveFrTo_OnSelect(EventPtr event)
{
	ControlType *controlP;
	TDataSet *DS;
	TDBGrid *grid;
    //  
	controlP = (ControlType *)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, event->data.ctlSelect.controlID));
	if (event->data.ctlSelect.controlID == chbActiveTo){
	  DS = DSAccTo;
	  grid = DBGridTo;
	}  
	else{
	  DS = DSAccFr;
	  grid = DBGridFr;
	}  
	    
	if (CtlGetValue(controlP)){
      DS->OnFuncValidateRecType = &AccGetValidRec;
      ProgressBar->Start(0, DS->RecCount(), " ");
      DS->set_Filtered(true);
	  grid->InitGrid();
      ProgressBar->Finish();
	}
	else
	{
      DS->set_Filtered(false);
	  grid->InitGrid();
	}  
	FrmDrawForm(formCond);
	return true;
}

Boolean ReleaseFiltered(){
  ControlType *controlP;
	
    //  
  //form = FrmGetActiveForm();
  controlP = (ControlType *)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, chbActiveTo));
  CtlSetValue(controlP, 0);
  controlP = (ControlType *)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, chbActiveFr));
  CtlSetValue(controlP, 0);

  DSAccTo->set_Filtered(false);
  DSAccFr->set_Filtered(false);
}



Boolean frmCond_HandleEvent(EventPtr event)
{
	Boolean handled = false;
	FieldPtr PField;

	switch (event->eType)
	{	case keyDownEvent :
	        if (DBGridTo) handled = DBGridTo->keyDownEventHandler(event);
			if (DBGridFr) handled = DBGridFr->keyDownEventHandler(event);
			break;
		case tblSelectEvent :
			switch (event->data.tblSelect.tableID)
			{
				// tblAccTo receives an event
				case tblAccTo:
					handled = DBGridTo->tblSelectEventHandler(event);
	                RefreshCountLabels();
					break;
				case tblCond:
					handled = DBGridCond->tblSelectEventHandler(event);
					break;
				// tblAccFr receives an event
				case tblAccFr:
					handled = DBGridFr->tblSelectEventHandler(event);
	                RefreshCountLabels();
					break;
			}
			break;
		case fldEnterEvent:
			switch (event->data.fldEnter.fieldID)
			{
				// edDateFrom receives an event
				case edDateFrom:
                    handled = DateEditFr->OnfldEnter(event);				
					break;
				case edDateTo:
                    handled = DateEditTo->OnfldEnter(event);				
					break;
			}
			break;
		case ctlSelectEvent:
			switch (event->data.ctlSelect.controlID)
			{
				// chbActiveTo receives an event
				case chbActiveTo:
					handled = frmCond_chbActiveFrTo_OnSelect(event);
					break;
				// chbActiveFr receives an event
				case chbActiveFr:
					handled = frmCond_chbActiveFrTo_OnSelect(event);
					break;
				// btnOk receives an event
				case btnOk:
					handled = frmCond_btnOk_OnSelect(event);
					break;
				// btnCancel receives an event
				case btnCancel:
					handled = frmCond_btnCancel_OnSelect(event);
					break;
				// btnTemp receives an event
				/*case btnTemp:
					CondSave();
					handled = frmCond_btnTemp_OnSelect(event);
					break;*/
				// btnNew receives an event
				case btnNew:
				    ReleaseFiltered();
					handled = frmCond_btnNew_OnSelect(event);
					break;
				// ptrSelectFr receives an event
				case ptrSelectFr:
					handled = ComboBoxFr->ctlSelectEventHandler(event);
					break;
				// btnOk receives an event
				case ptrSelectTo:
					handled = ComboBoxTo->ctlSelectEventHandler(event);
					break;
			}
			break;
		case sclExitEvent :
			switch (event->data.sclExit.scrollBarID)
			{  UInt16 DSPosition;
				// sclCond receives an event
				case sclCond:
				    ReleaseFiltered();
                    DSPosition = DSCond->get_Position();					
					CondSave();
                    DSPosition = DSCond->get_Position();					
					handled = DBGridCond->sclExitEventHandler(event);
                    DSPosition = DSCond->get_Position();					
					CondLoad();
					break;
					
					break;
				// scrlTables receives an event
				case scrlTablesTo:
					handled = DBGridTo->sclExitEventHandler(event);
					break;
				case scrlTablesFr:
					handled = DBGridFr->sclExitEventHandler(event);
					break;
			}
			break;
		case frmCloseEvent:
            //SysFatalAlert ("frmCond");
		    frmCond_ReleaseData();
			break;
		case frmOpenEvent:
		    InitDataSets();
		    TablePtr PTableTo, PTableFr;
	        ScrollBarPtr ScrollBarP;
			
			formCond = FrmGetActiveForm();
			
	        PTableTo = (TablePtr)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, tblAccTo));
	        PTableFr = (TablePtr)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, tblAccFr));
	        ScrollBarP = (ScrollBarPtr)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, scrlTablesTo));
			
			DBGridTo = new TDBGrid(ScrollBarP, PTableTo, DSAccTo);
	        ScrollBarP = (ScrollBarPtr)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, scrlTablesFr));
			DBGridFr = new TDBGrid(ScrollBarP, PTableFr, DSAccFr);
			
	  		DBGridTo->AddColumn(DSAccTo->GetFieldByName("C"), checkboxTableItem, NULL);
		    DBGridTo->AddColumn(DSAccTo->GetFieldByName(" "), customTableItem, NULL);
			
	  		DBGridFr->AddColumn(DSAccFr->GetFieldByName("C"), checkboxTableItem, NULL);
		    DBGridFr->AddColumn(DSAccFr->GetFieldByName(" "), customTableItem, NULL);
			
			DBGridTo->InitGrid();
			DBGridFr->InitGrid();
			
			//  -   
			PField = (FieldPtr)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, edDateFrom));
			DateEditFr = new TDateEdit(PField);
			PField = (FieldPtr)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, edDateTo));
			DateEditTo = new TDateEdit(PField);
			
			{
			  ListType* PList; 
			  ControlPtr PPopupTr;
			  
	          PList = (ListType*)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, lstSelect));
			  
              PPopupTr = (ControlPtr) FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, ptrSelectFr));			  
			  ComboBoxFr = new TComboBox(PList, PPopupTr);
			  ComboBoxFr->OnChange = ComboBoxChangeFr;
			  
              PPopupTr = (ControlPtr) FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, ptrSelectTo));			  
			  ComboBoxTo = new TComboBox(PList, PPopupTr);
			  ComboBoxTo->OnChange = ComboBoxChangeTo;
			}  
			
			// Grid    
	        PTableTo = (TablePtr)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, tblCond));
	        ScrollBarP = (ScrollBarPtr)FrmGetObjectPtr(formCond, FrmGetObjectIndex(formCond, sclCond));
			DBGridCond = new TDBGrid(ScrollBarP, PTableTo, DSCond);
			
			DBGridCond->AddColumn(DSCond->GetFieldByName("C"), checkboxTableItem, NULL); 
			DBGridCond->AddColumn(DSCond->GetFieldByName(""), textTableItem, NULL);
			 
	        if (!DSCond->DBExists()) DSCond->CreateDB();
			else DSCond->Open();
			if (DSCond->RecCount() == 0){
  			   frmCond_btnNew_OnSelect(NULL);
			}    
			DBGridCond->InitGrid();
			CondLoad();
			
			FrmDrawForm(formCond);
			handled = true;
			break;
		default:
			break;
	}
	return handled;
}
