 
/************************************************************************
    
 ***********************************************************************/

#include <PalmOS.h>
#include "FinDiagrCPP.hpp"
#include "FinDiagrCPP_res.hpp"
#include "TDBGrid.hpp"
#include "TProgressBar.hpp"
#include "TDataSet.hpp"
#include "FinDataModule.hpp"
#include "CommonFunc.hpp"

TDBGrid *DB_Grid = NULL;
MyDateType Date_Fr, Date_To;
Char *LabelText = NULL;
Char *LabelSumText = NULL;
Char *LabelCountText = NULL;

Boolean ShowTransOfPeriod(MyDateType DateFr, MyDateType DateTo){
  Date_Fr = DateFr;
  Date_To = DateTo;
  FrmPopupForm(frmTrans);
}
   
Boolean frmTrans_Init(void)
{
  FormPtr form;
  
  if (DB_Grid == NULL){
    TablePtr tableP;
	ScrollBarPtr ScrollBarP;
	 
	form = FrmGetActiveForm();
    tableP = (TablePtr)FrmGetObjectPtr(form, FrmGetObjectIndex(form, tblTransView));
    ScrollBarP = (ScrollBarPtr)FrmGetObjectPtr(form, FrmGetObjectIndex(form, sclTblTrans));
	
    DB_Grid = new TDBGrid(ScrollBarP, tableP, DSTrans);
	
    //DSAccTo->SetLinkDS(DSTrans->GetFieldByName("ACC_TO_ID"), DSAccTo->GetFieldByName("ID"));
    //DSAccFr->SetLinkDS(DSTrans->GetFieldByName("ACC_FR_ID"), DSAccFr->GetFieldByName("ID"));
	
	DB_Grid->AddColumn(DSTrans->GetFieldByName(""), textTableItem, NULL);
    DB_Grid->AddColumn(DSAccTo->GetFieldByName(" "), customTableItem, NULL);
    DB_Grid->AddColumn(DSAccFr->GetFieldByName(" "), customTableItem, NULL);
    //DB_Grid->AddColumn(fldAccNameTo, labelTableItem, NULL);
	DB_Grid->AddColumn(DSTrans->GetFieldByName(""), textTableItem, NULL);
	DB_Grid->AddColumn(DSCurr->GetFieldByName("$"), textTableItem, NULL);
	//DB_Grid->AddColumn(NOTE, textTableItem, NULL);
	//DB_Grid->AddColumn(FMIRROR, customTableItem, NULL);
	
	//DB_Grid->AddColumn(ACC_TO_ID, textTableItem, NULL);
  }
  SetTransFiltered(false);
  if (!SetTransFiltered(true, &Date_Fr, &Date_To)) return false;
  
    DSAccTo->SetLinkDS(DSTrans->GetFieldByName("ACC_TO_ID"), DSAccTo->GetFieldByName("ID"));
    DSAccFr->SetLinkDS(DSTrans->GetFieldByName("ACC_FR_ID"), DSAccFr->GetFieldByName("ID"));
    //DSCurr->SetLinkDS (DSTrans->GetFieldByName("CURRENCY_ID"), DSCurr->GetFieldByName("ID"));
	DB_Grid->InitGrid();
	//    
	{
    Char *n1,*n2;
		
	//n =	CtlGetLabel ((ControlType *)FrmGetObjectPtr(form, FrmGetObjectIndex(form, lblPeriod)));
	//MemPtrFree(n);
    if (!LabelText) LabelText = (Char *)MemPtrNew(40);
	n1 = (Char *)MemPtrNew(11);
	n2 = (Char *)MemPtrNew(11);
	
    DateToStr(Date_Fr.day, Date_Fr.month, Date_Fr.year, n1);
    DateToStr(Date_To.day, Date_To.month, Date_To.year, n2);
    StrPrintF(LabelText, " %s  %s", n1, n2);
	MemPtrFree(n1);
	MemPtrFree(n2);
    CtlSetLabel((ControlType *)FrmGetObjectPtr(form, FrmGetObjectIndex(form, lblPeriod)),
	  LabelText);	  
	}
	//  
	{  
	  UInt16 i, RecCount;
      FlpCompFloat sumAmt;
      Char *n1;
	  
  	  RecCount = DSTrans->RecCount();
	  sumAmt.f = 0;
      for(i = 0; i < RecCount; ++i){
	    FlpCompFloat *amt;
	    Int32 index;
	    Boolean *FOWNCURRENCY;
		FlpCompFloat *rate;
		
  	    DSTrans->set_Position(i);
	    amt = (FlpCompFloat *)DSTrans->GetFieldData(DSTrans->GetFieldByName(""), false);
		FOWNCURRENCY = (Boolean *)DSTrans->GetFieldData(DSTrans->GetFieldByName("FOWNCURRENCY"), false);
		
		if (!(*FOWNCURRENCY)) //   
		  rate = (FlpCompFloat *)DSCurr->GetFieldData(DSCurr->GetFieldByName("RATE"));
		else //  
  		  rate = (FlpCompFloat *)DSTrans->GetFieldData(DSTrans->GetFieldByName("CURRENCY_RATE"), false);
		  
		sumAmt.f = sumAmt.f + amt->f*rate->f;  
	  }	
	  
	  if (!LabelSumText) LabelSumText = (Char *)MemPtrNew(30);
	  n1 = (Char *)MemPtrNew(20);
      FloatToCurrency(sumAmt, n1, 2);   
      StrPrintF(LabelSumText, ": %s", n1);
	  MemPtrFree(n1);
      CtlSetLabel((ControlType *)FrmGetObjectPtr(form, FrmGetObjectIndex(form, lblSumAmt)),
	    LabelSumText);
		
	  if (!LabelCountText) LabelCountText = (Char *)MemPtrNew(30);
	  //n1 = StrIToA(n1, RecCount);
      StrPrintF(LabelCountText, ": %i", RecCount);
      CtlSetLabel((ControlType *)FrmGetObjectPtr(form, FrmGetObjectIndex(form, lblCount)),
	    LabelCountText);
		
	  //if (!LabelCondText) LabelCondText = (Char *)MemPtrNew(40);
      CtlSetLabel((ControlType *)FrmGetObjectPtr(form, FrmGetObjectIndex(form, lblCondName)),
	    DSCond->GetFieldData(DSCond->GetFieldByName(""), false));
	}
	
}

Boolean frmTrans_HandleEvent(EventPtr event)
{
	FormPtr form;
	Boolean handled = false;
    TablePtr tableP;
    UInt16 iIndex;
	ScrollBarPtr ScrollBarP;

	switch (event->eType)
	{	case keyDownEvent :
	        if (DB_Grid) handled = DB_Grid->keyDownEventHandler(event);
			break;
	
		case sclExitEvent :
			switch (event->data.sclExit.scrollBarID)
			{
				// sclTblTrans receives an event
				case sclTblTrans:
           		    handled = DB_Grid->sclExitEventHandler(event);
					break;
			}
			break;
		case ctlSelectEvent:
			switch (event->data.ctlSelect.controlID)
			{
				// btnClose receives an event
				case btnClose:
	                DSAccTo->ClearLink();
	                DSAccFr->ClearLink();
 	                DSTrans->set_Filtered(false);
  			        if (DB_Grid != NULL) delete DB_Grid;
  			        if (LabelText != NULL) MemPtrFree(LabelText);
  			        if (LabelSumText != NULL) MemPtrFree(LabelSumText);
  			        if (LabelCountText != NULL) MemPtrFree(LabelCountText);
					LabelText = NULL;
					LabelSumText = NULL;
					LabelCountText = NULL;
			        DB_Grid  = NULL; 
				    FrmReturnToForm (frmChart); 
					handled = true;
					break;
			}
			break;
		case frmCloseEvent:
			// Insert code when form closes:
			//if (DSTrans != NULL) delete DSTrans;
            //SysFatalAlert ("frmTrans");
			 
			if (DB_Grid != NULL) delete DB_Grid;
			//DSTrans = NULL;
			DB_Grid  = NULL; 
			break;
		case frmOpenEvent:
   	        form = FrmGetActiveForm();
			FrmDrawForm(form);
			InitDataSets();
			frmTrans_Init();
			FrmDrawForm(form);
			handled = true;
			break;
		default:
			break;
	}

	return handled;
}
